<?php
/**
 * Result processing API for ABU
 * @author Christian Amaonwu <amakris24@gmail.com>
 */


/**
 * Determine the graduation level of a student from
 * the programme duration
 *  - student_id : the id of the students
 * @param array $params
 * @return int
 */
function get_student_graduation_level(array $params)
{
	$id=(isset($params['student_id']))?$params['student_id']:0;
    $grad_level=4;
    //do we have student id
    if(!$id)
    {
    	return $grad_level;
    }
     //first we need to get the student's department id
     $did=0;
     $facultyid=get_student_info("stddepartment_id",$id);
     //do we have the department id
     if(!$did)
     {
     	return $grad_level;
     }

     //ok we need to get the duration
      $duration=0;
      $sql="SELECT duration FROM dept_options
            WHERE dept_id='%d'
            LIMIT 1 ";

      global $connect;
      $res=mysql_query(sprintf($sql,$did),$connect);
      if(mysql_num_rows($res)>0)
      {
      	while($d=mysql_fetch_assoc($res))
      	{
			$duration=$d['duration'];
			if(strlen($duration)>0 && $duration>0)
			{
				$grad_level=$duration;
			}
      	}
      }

      return $grad_level;
}

function check_final_year_carry_over_status(array $params)
{
   $id=(isset($params['student_id']))?$params['student_id']:0;
   $status=array();
   $status['has_error']=0;
   $status['error_message']='';
   $status['has_carryover']=0;
   $status['carry_over']='';

   if(!$id)
   {
   	 $status['has_error']=1;
   	 $status['error_message']="Missing student id for checking carry over status";
   	 return $status;
   }
   //check the carry over status for this student
   $check=array();
   $check=get_carryover_courses(array("student_id"=>$id));
   //check if we have any error
   if($check['has_error']!==0)
   {
   	//we have an error
   	$status['has_error']=1;
   	$status['error_message']=$check['error_message'];
   	return $status;
   }
   //ok no error do he or she has a carry over
   $carries=array();
   $carries=$check['carry_overs'];
   if(!count($carries))
   {
   	//does not have any carry over
   	 return $status;
   }
   //the carry overs it self
   $lists=array();
   //the courses the student carried over
   $lists=$carries['carry_overs'];
   //if this student does not have any carry over entries return
   if(!count($lists))
   {
   	//does not have any carry over lists
   	return $status;
   }
   //ok has some carry overs process it
   $str=array();
   //we are only interested in the course code
   foreach($lists as $k=>$v)
   {
   	 $str[]=$k;
   }

   $status['has_carryover']=1;
   $status['carry_over']=join(",",$str);
   return $status;
}


/**
 * finds a students class if they are in final year
 * - remarks : the students remarks so far as stored in cgpa
 * - cgpa : the current cummulative grade point average of the student
 * @param array $params
 * @return string
 */

function which_class_is_student(array $params)
{
	$new_remarks='';
	$remarks=(isset($params['remarks']))?$params['remarks']:'';
	$cgpa=(isset($params['cgpa']))?$params['cgpa']:0;
    if(strlen($remarks)>0)
    {
    	$new_remarks=$remarks;
    }else if($cgpa>=4.50)
    {
    	$new_remarks="1";
    }else if($cgpa>=3.50 && $cgpa<4.50)
    {
    	$new_remarks="2.1";
    }else if($cgpa>=2.40 && $cgpa<3.50)
    {
    	$new_remarks="2.2";
    }else if($cgpa>=1.50 && $cgpa<2.40)
    {
    	$new_remarks="3";
    }else
    {
    	$new_remarks="Pass";
    }

return $new_remarks;

}
/**
 * Checks probation status and returns remarks
 * - remarks : the previous remarks saved in db
 * - cgpa : the current cummulative grade point average
 * - probation_level : the previous probation level
 * @param array $params
 * @return string
 */
function check_probation(array $params)
{
   $remarks=(isset($params['remarks']))?$params['remarks']:'';
   $cgpa=(isset($params['cgpa']))?$params['cgpa']:0;
   $probation=(isset($params['probation_level']))?$params['probation_level']:0;

   $new_remarks='';
   if($probation==4)
   {
     $new_remarks="Withdrawn";
     return $new_remarks;
   }

   $searching="Probation";
   $check=0;
   if($cgpa>=1)
   {
   	  //student is on probation check f he or she has been on probation before

   	  $check=strpos($remarks,$searching);
   	  if($check)
   	  {
   	  	//we ned to remove the probation str from the remarks
   	  	$end=strlen($remarks)-strlen($searching);
        $new_remarks=substr($remarks,0,$end);
   	  }else
   	  {
   	  	$new_remarks=$remarks;
   	  }
   }else
   {
   	  //this person is still on probation check if we have
   	  //added the probation string
	   $check=strpos($remarks,$searching);
	   if(!$check)
	   {
			//we need to add it
           $new_remarks=$remarks." ".$searching;
	   }else
	   {
	   	$new_remarks=$remarks;
	   }
   }

  return $new_remarks;

}

/**
 * Checks if a student has completely earned unit or not
 *
 * @param array $params
 * @return bool
 */


function has_complete_earned_units(array $params)
{ //var_dump($params);exit;
   $id=(isset($params['student_id']))?$params['student_id']:0;
   $tcue=(isset($params['tcue']))?$params['tcue']:0;
   $curr_level=(isset($params['current_level']))?$params['current_level']:0;
   $grad_level=(isset($params['grad_level']))?$params['grad_level']:4;
   $entry_level=0;
   $bool=false;

   if(!$id||!$tcue||!$curr_level)
   {
   	return $bool;
   }
   //ok we get this student entry level
   $entry=get_student_entry_level(array("student_id"=>$id));
  //have we an error
  if($entry['has_error']!==0)
  {
  	return $bool;
  }
  //ok we assume that we do not have an error
  $entry_level=$entry['entry_level'];

  //for 100 level
  if($curr_level==1)
  {
  	$bool=($tcue>=24)?true:false;
  }
  //for 200 level
  if($curr_level==2 && $entry_level==1)
  {
  	$bool=($tcue>=48)?true:false;
  }
  //for 200 level with entry level of 200
  if($curr_level==2 && $entry_level==2)
  {
     $bool=($tcue>=24)?true:false;
  }
  // for 300 level and entry level of 100
  if($curr_level==3 && $entry_level==1)
  {
    $bool=($tcue>=72)?true:false;
  }
  //for 300 level with entry level of 200
  if($curr_level==3 && $entry_level==2)
  {
  	$bool=($tcue>=48)?true:false;
  }
  //for 400 level with entry level of 100
  if($curr_level==4 && $entry_level==1)
  {
  	$bool=($tcue>=96)?true:false;
  }

  //for 400 level with entry level 200
  if($curr_level==4 && $entry_level==2)
  {
    $bool=($tcue>=72)?true:false;
  }

  //for 500 level with entry level of 100
  if($curr_level==5 && $entry_level==1)
  {
    $bool=($tcue>=120)?true:false;
  }
//for 500 level with entry level of 200
if($curr_level==5 && $entry_level==2)
{
	$bool=($tcue>=96)?true:false;
}

if($curr_level==4 && $curr_level=$grad_level)
{
   if($entry_level==1)
   {
   	 $bool=($tcue>=120)?true:false;
   }else
   {
   	$bool=($tcue>=90)?true:false;
   }
}else if($curr_level==5 && $curr_level=$grad_level)
{
	if($entry_level==1)
	{
		$bool=($tcue>=150)?true:false;
	}else
	{
		$bool=($tcue>=120)?true:false;
	}

}

return $bool;
}

function compute_student_degree_class(array $params)
{
	$id=(isset($params['student_id']))?$params['student_id']:0;
   $cgpa=(isset($params['cgpa']))?$params['cgpa']:0;
   $remarks=(isset($params['remarks']))?$params['remarks']:'';
   $curr_level=(isset($params['current_level']))?$params['current_level']:0;
   $semester=(isset($params['semester']))?$params['semester']:'';
   $tcue=(isset($params['tcue']))?$params['tcue']:0;
   $grad_level=(isset($params['grad_level']))?$params['grad_level']:4;

   $newremark="";
  //we need to get the entry level
  //we must have student id
  if(!$id)
  {
  	return $remarks;
  }
  $entry=array();
  $iecu="IECU";
  $entry=get_student_entry_level(array("student_id"=>$id));
  //check for error
  if($entry['has_error']!==0)
  {
  	return $remarks;
  }
  //the entry level
  $entry_level=$entry['entry_level'];

  //check students degree class
  if($curr_level==$grad_level && $semester=="Second Semester")
  {
    //check if this student has a complete earned units,if not add to remark IECU
      if(!has_complete_earned_units(array("student_id"=>$id,
                                         "grad_level"=>$grad_level,
                                         "current_level"=>$curr_level,
                                         "tcue"=>$tcue)))
                                         {
											//the student has completely earned units
											$newremark=$remarks." ".$iecu;
                                         }
  }

  //check the case where semester is second and the curr level is less than grad level
  if($semester=="Second Semester" && $curr_level<$grad_level)
  {
  	 //if this student does not have the completely earned units add IECU to remarks
  	 if(!has_complete_earned_units(array("student_id"=>$id,
                                         "grad_level"=>$grad_level,
                                         "current_level"=>$curr_level,
                                         "tcue"=>$tcue)))
                                         {
										   $newremark=$remarks." ".$iecu;
                                         }else
                                         {
                                         	//check this students carry over status
 											$carry_check=array();
											$carry_check=check_final_year_carry_over_status(array("student_id"=>$id));
											//do we have any error
											if($carry_check['has_error']!==0)
											{
												//check if we have a carry over
												$carrylist=$carry_check['carry_overs'];
												//the length tells if any carry over is found
												if(strlen($carrylist)==0)
												{
													$newremark="Pass";
												}else
												{
													$newremark=$remarks;
												}
											}
                                         }
  }

  //check case where semester is first semester and level is 400
  if($semester=="First Semester" && $curr_level<=400)
  {
  	 $newremark=$remarks;
  }

  return $newremark;
}
/**
 * Gets the entry level of a student
 * - student_id : the student id to fetch entry level for
 * @param array $params
 * @return array
 */
function get_student_entry_level(array $params)
{
   global $connect;
   $status=array();
   $status['has_error']=0;
   $status['error_message']='';
   $status['entry_level']=0;
   $id=(isset($params['student_id']))?$params['student_id']:0;
   if(!$id)
   {
   	$status['has_error']=1;
   	$status['error_message']="Missing required student id for finding entry level";
   	return $status;
   }
   $sql="SELECT std_id,MIN(clevel_id) AS entrylevel
         FROM course_reg
         WHERE std_id='%d'
         GROUP BY std_id";

    $res=mysql_query(sprintf($sql,$id)) or die(mysql_error());
    if(mysql_num_rows($res)>0)
    {
    	while($d=mysql_fetch_assoc($res))
    	{
		  $status['entry_level']=$d['entrylevel'];
    	}
    }

    return $status;
}
/**
 * Create a new entry in the students_cgpa
 *  - student_id : the student id
 *  - student_probation : indicates if a student is on probation
 *  - core_courses : the core courses the student registered with grades
 *  - elective_courses : the elective courses the students registered with grades
 *  - student_level : the level of the student
 *  - session_id : the current session id
 *  - semester : the student current semester
 *  - is_update : indicates whether we are updating a record
 *  - carry_overs : an array of all the current carry over of the student
 *  - rcu : the current registered credit units of the student
 *  - trcu : total registered credit units of the students
 *  - cue : the current credit units earned by the student
 *  - tcue : the total credit units earned by the student so far
 *  - gpa : the current gpa of the student
 *  - cgpa : the current cgpa of the student
 *  - probation : the probation status of the student
 *  - remarks : the current remarks
 */


function create_cgpa_entry(array $params)
{ 
  //get the parameters
  $std_id=(isset($params['student_id']))?$params['student_id']:0;
  $probation=(isset($params['student_probation']))?$params['student_probation']:0;
  $cores=(isset($params['core_courses']))?$params['core_courses']:array();
  $electives=(isset($params['elective_courses']))?$params['elective_courses']:array();
  $level=(isset($params['student_level']))?$params['student_level']:0;
  $session=(isset($params['session_id']))?$params['session_id']:0;
  $semester=(isset($params['semester']))?$params['semester']:0;
  //are we doing an update for a given semester
  $isupdate=(isset($params['is_update']))?$params['is_update']:0;
  //the carryover courses
  $carryovers=(count($params['carry_overs'])>0)?$params['carry_overs']:array();
  //the registered credit unit for the given semester
  $rcu=(isset($params['rcu']))?$params['rcu']:0;
  //the total registered credit unit
  $trcu=(isset($params['trcu']))?$params['trcu']:0;
 //the credit unit earned for the given semester
  $cue=(isset($params['cue']))?$params['cue']:0;
  //the total credit unit earned
  $tcue=(isset($params['tcue']))?$params['tcue']:0;
  //the grade point average
  $gpa=(isset($params['gpa']))?$params['gpa']:0;
  //the commulative grade point average
  $cgpa=(isset($params['cgpa']))?$params['cgpa']:0;
  //the remarks
  $remarks=(isset($params['remarks']))?$params['remarks']:'';
	//the commulative grade point 
  $tcp=(isset($params['tcp']))?$params['tcp']:0;
  
  $ptcp=(isset($params['ptcp']))?$params['ptcp']:0;

  $status=array();

  $status['has_error']=0;

  $status['error_message']='';

 //there are key fields that must not be empty for an entry
 if(!$std_id||!$level||!$session||!$semester)
 {
 	//we have an error these fields must not be empty
 	$status['has_error']=1;
 	$status['error_message']='Some of the required key field for creating cgpa entry are missing';
 	return;
 }

 //first we try to see if we can update an existing records
 $csql="select * from students_cgpa        
        WHERE std_id='$std_id'
        AND session_id='$session'
        AND student_level='$level'
        AND student_semester='$semester'";
$cresult = mysql_query($csql);
$cnum = mysql_num_rows($cresult);
$crow = mysql_fetch_assoc($cresult);

if($crow){

//var_dump($crow);exit;
//}
		
		
check_cgpa_update(array("student_id"=>$std_id,
                              "session_id"=>$session,
                              "semester"=>$semester,
                              "probation"=>$probation,
                              "remarks"=>$remarks,
                              "core_courses"=>$cores,
                              "elective_courses"=>$electives,
                              "level"=>$level,
                              "rcu"=>$rcu,
                              "trcu"=>$trcu,
                              "cue"=>$cue,
                              "tcue"=>$tcue,
                              "gpa"=>$gpa,
                              "cgpa"=>$cgpa,
							  "tcp"=>$tcp,
							  "ptcp"=>$ptcp));
                             }else{
                             	//we try and add a new cgpa entry
                             	$check=add_new_cgpa_entry(array("student_id"=>$std_id,
                                                                 "session_id"=>$session,
                                                                 "semester"=>$semester,
                                                                 "core_courses"=>$cores,
                                                                 "probation"=>$probation,
                                                                 "remarks"=>$remarks,
                                                                 "elective_courses"=>$electives,
                                                                 "level"=>$level,
                                                                 "rcu"=>$rcu,
                                                                 "trcu"=>$trcu,
                                                                 "cue"=>$cue,
                                                                 "tcue"=>$tcue,
                                                                 "gpa"=>$gpa,
                                                                 "cgpa"=>$cgpa,
																 "tcp"=>$tcp,
																 "ptcp"=>$ptcp));

								//do we have any error in adding new entry
                                if($check['has_error']!==0)
                                {
                                	//we have an error
                                	$status['has_error']=1;
                                	$status['error_message']=$check['error_message'];
                                	return $status;
                                }
                             }
   //ok we had no error adding new cgpa entry handle the carryovers
   if(count($carryovers))
     {
	    $check2=add_carryover_courses(array("student_id"=>$std_id
		                                   ,"carry_overs"=>$carryovers));
		//if we have an error return it
		  if($check2['has_error']!==0)
		     	  {
			   	    return $check2;
			   	    $status['has_error']=1;
			   	    $status['error_message']=$check2['error_message'];
			   	    return $status;
				  }
    }
    //if we get to this stage we need to update the carry over courses log
    /**
     * This invloves checking the carry over lists and removing those ones that
     * the student has sat for again and cleared. we have to remove it from the list
     *
     */
    $c_update=update_carryover_courses(array("student_id"=>$std_id,
                                             "core_courses"=>$cores,
                                             "elective_courses"=>$electives));
      //if we encounter an error return it
       if($c_update['has_error']!==0)
           {
              	$status['has_error']=1;
               	$status['error_message']=$c_update['error_message'];
           }
      return $status;

}

/**
 * try updating a record that already exists
 * this is useful when cgpa entry is updated
 * for any reason and prevents creation of a new
 * entry. This prevents duplicate entries
 *
 * @param array $data
 * @return bool ;true on success and false otherwise
 */
 
 function createupda_cgpa_entry_new(array $params)
{
  //get the parameters
  $std_id=(isset($params['student_id']))?$params['student_id']:0;
  $probation=(isset($params['student_probation']))?$params['student_probation']:0;
  $cores=(isset($params['core_courses']))?$params['core_courses']:array();
  $electives=(isset($params['elective_courses']))?$params['elective_courses']:array();
  $level=(isset($params['student_level']))?$params['student_level']:0;
  $session=(isset($params['session_id']))?$params['session_id']:0;
  $semester=(isset($params['semester']))?$params['semester']:0;
  //are we doing an update for a given semester
  $isupdate=(isset($params['is_update']))?$params['is_update']:0;
  //the carryover courses
  $carryovers=(count($params['carry_overs'])>0)?$params['carry_overs']:array();
  //the registered credit unit for the given semester
  $rcu=(isset($params['rcu']))?$params['rcu']:0;
  //the total registered credit unit
  $trcu=(isset($params['trcu']))?$params['trcu']:0;
 //the credit unit earned for the given semester
  $cue=(isset($params['cue']))?$params['cue']:0;
  //the total credit unit earned
  $tcue=(isset($params['tcue']))?$params['tcue']:0;
  //the grade point average
  $gpa=(isset($params['gpa']))?$params['gpa']:0;
  //the commulative grade point average
  $cgpa=(isset($params['cgpa']))?$params['cgpa']:0;
  //the remarks
  $remarks=(isset($params['remarks']))?$params['remarks']:'';


  $status=array();

  $status['has_error']=0;

  $status['error_message']='';

 //there are key fields that must not be empty for an entry
 if(!$std_id||!$level||!$session||!$semester)
 {
 	//we have an error these fields must not be empty
 	$status['has_error']=1;
 	$status['error_message']='Some of the required key field for creating cgpa entry are missing';
 	return;
 }

 //first we try to see if we can update an existing records
check_cgpa_update(array("student_id"=>$std_id,
                              "session_id"=>$session,
                              "semester"=>$semester,
                              "probation"=>$probation,
                              "remarks"=>$remarks,
                              "core_courses"=>$cores,
                              "elective_courses"=>$electives,
                              "level"=>$level,
                              "rcu"=>$rcu,
                              "trcu"=>$trcu,
                              "cue"=>$cue,
                              "tcue"=>$tcue,
                              "gpa"=>$gpa,
                              "cgpa"=>$cgpa));
/*							  
  if(!check_cgpa_update(array("student_id"=>$std_id,
                              "session_id"=>$session,
                              "semester"=>$semester,
                              "probation"=>$probation,
                              "remarks"=>$remarks,
                              "core_courses"=>$cores,
                              "elective_courses"=>$electives,
                              "level"=>$level,
                              "rcu"=>$rcu,
                              "trcu"=>$trcu,
                              "cue"=>$cue,
                              "tcue"=>$tcue,
                              "gpa"=>$gpa,
                              "cgpa"=>$cgpa)))
                             {
                             	//we try and add a new cgpa entry
                             	$check=add_new_cgpa_entry(array("student_id"=>$std_id,
                                                                 "session_id"=>$session,
                                                                 "semester"=>$semester,
                                                                 "core_courses"=>$cores,
                                                                 "probation"=>$probation,
                                                                 "remarks"=>$remarks,
                                                                 "elective_courses"=>$electives,
                                                                 "level"=>$level,
                                                                 "rcu"=>$rcu,
                                                                 "trcu"=>$trcu,
                                                                 "cue"=>$cue,
                                                                 "tcue"=>$tcue,
                                                                 "gpa"=>$gpa,
                                                                 "cgpa"=>$cgpa));

								//do we have any error in adding new entry
                                if($check['has_error']!==0)
                                {
                                	//we have an error
                                	$status['has_error']=1;
                                	$status['error_message']=$check['error_message'];
                                	return $status;
                                }
                             }*/
   //ok we had no error adding new cgpa entry handle the carryovers
   if(count($carryovers))
     {
	    $check2=add_carryover_courses(array("student_id"=>$std_id
		                                   ,"carry_overs"=>$carryovers));
		//if we have an error return it
		  if($check2['has_error']!==0)
		     	  {
			   	    return $check2;
			   	    $status['has_error']=1;
			   	    $status['error_message']=$check2['error_message'];
			   	    return $status;
				  }
    }
    //if we get to this stage we need to update the carry over courses log
    /**
     * This invloves checking the carry over lists and removing those ones that
     * the student has sat for again and cleared. we have to remove it from the list
     *
     */
    $c_update=update_carryover_courses(array("student_id"=>$std_id,
                                             "core_courses"=>$cores,
                                             "elective_courses"=>$electives));

      //if we encounter an error return it
       if($c_update['has_error']!==0)
           {
              	$status['has_error']=1;
               	$status['error_message']=$c_update['error_message'];
           }
      return $status;

}

/**
 * try updating a record that already exists
 * this is useful when cgpa entry is updated
 * for any reason and prevents creation of a new
 * entry. This prevents duplicate entries
 *
 * @param array $data
 * @return bool ;true on success and false otherwise
 */

 
function check_cgpa_update(array $data)
{ //var_dump($data);exit;
	$status=false;
	global $connect;

   if(!count($data))
   {
   	return false;
   }
   $str="UPDATE students_cgpa
         SET
         core_courses='%s'
        ,elective_courses='%s'
        ,rcu='%d'
        ,in_probation='%d'
        ,remarks='%s'
        ,trcu='%d'
        ,cue='%d'
        ,tcue='%d'
        ,gpa='%01.2f'
        ,cgpa='%01.2f'
		,tcp='%d'
		,ptcp='%d'
        WHERE std_id='%s'
        AND session_id='%s'
        AND student_level='%s'
        AND student_semester='%s'
        LIMIT 1
        ";
      $ret=mysql_query(sprintf($str,serialize($data['core_courses'])
                                    ,serialize($data['elective_courses'])
                                    ,$data['rcu']
                                    ,$data['probation']
                                    ,$data['remarks']
                                    ,$data['trcu']
                                    ,$data['cue']
                                    ,$data['tcue']
                                    ,floatval($data['gpa'])
                                    ,floatval($data['cgpa'])
									,$data['tcp']
									,$data['ptcp']
                                    ,$data['student_id']
                                    ,$data['session_id']
                                    ,$data['level']
                                    ,$data['semester']
                                    ),$connect);


 if(mysql_affected_rows($connect)>0)
 {
 	$status=true;
 }

 return $status;

}

/**
 * Computes the grade point average
 * - $data : an  array consisting of
 *    - $rcu :  registered credit unit
 *    - $tcp : total credit points
 * @param array $data
 * @return float
 */
function compute_gpa(array $data)
{
	$gp=(isset($data['gp']))?$data['gp']:0;
	$rcu=(isset($data['rcu']))?$data['rcu']:0;
	$gpa=0;
	if(!$rcu)
	{
		return $gpa;
	}
	$gpa=number_format(($gp/$rcu),2);
	return $gpa;
}


/**
 * Conputes the cummulative grade point avaerage
 * - $data : an array consisting of
 *   - prevtrcu : the previous total registered credit unit
 *   - rcu : registered credit unit
 *   - prevcgpa : previous commulative grade point average
 *   - tcp : total credit points
 * @param array $data
 * @return float
 */

function compute_cgpa(array $data) 
{ //var_dump($data);
  $prevtrcu=(isset($data['prevtrcu']))?$data['prevtrcu']:0;
  $rcu=(isset($data['rcu']))?$data['rcu']:0;
  $gp=(isset($data['gp']))?$data['gp']:0;
  $prevcgpa=(isset($data['prevcgpa']))?$data['prevcgpa']:0;

   $sum1=0;
   $sum1=$prevtrcu+$rcu;
   $cgpa=0;
   if($sum1<=0)
   {
   	return $cgpa;
   }

  $cgpa=(($prevtrcu * $prevcgpa + $gp)/($sum1));
  return number_format($cgpa,2);
}


/**
 * Gets all the course a student has registered
 * for a given session and semester
 *  - $data : an array consisting of
 *   - student_id : the student id
 *   - semester : the semester we are dealing with
 *   - session_id : the session we are dealing with
 * @param array $data
 * @return array
 *  consisting of status,courses
 */
function get_student_registered_courses(array $data)
{
	$id=(isset($data['student_id']))?$data['student_id']:0;
	$sid=(isset($data['session_id']))?$data['session_id']:0;
	$semester=(isset($data['semester']))?$data['semester']:'';
	global $connect;
	$result=array();
	$result['courses']=array();
	$result['has_record']=0;
	$result['has_error']=0;
	$result['error_message']='';
	//if any of these parameters are missing return
	if(!$id||!$sid||!$semester)
	{
		$result['has_error']=1;
		$result['error_message']="Missing required parameters for fetching a student registered courses";
		return $result;
	}

	$sql="SELECT DISTINCT
	         thecourse_id
	        ,stdcourse_custom2
	        ,stdcourse_custom1
	        ,csemester
	        ,c_unit
	        ,stdcourse_custom3
		,clevel_id
	       FROM course_reg
	       WHERE std_id='$id'
	          AND cyearsession='$sid'
	          AND csemester='$semester'
	        ";

	//pattern for testing for core or elective course
	$corepattern="/core/i";
	$ret=mysql_query($sql,$connect) or die(mysql_error());


			if(mysql_num_rows($ret)>0)
	         {
		       $result['has_record']=1;
		        $temp=array();
		        while($d=mysql_fetch_assoc($ret))
		        {
			      $course=new stdClass();
			      $course->courseCode=$d['stdcourse_custom2'];
			      $course->courseName=$d['stdcourse_custom1'];
			      $course->courseUnit=$d['c_unit'];
			      $course->courseId=$d['thecourse_id'];
			      $course->courseLevel=$d['clevel_id'];
			      if($d['csemester']=='First Semester')
			        {
				     $course->semester=1;
			        }else
			        {
				     $course->semester=2;
			        }

			       if(preg_match($corepattern,$d['stdcourse_custom3']))
			      {
				     $course->courseType="core";
			      }else
			      {
				    $course->courseType="elective";
			      }
			       $temp[]=$course;
		      }
		$result['courses']=$temp;
	}else
	{
      $result['has_error']=1;
      $result['error_message']="No course records found for this student";

	}

	return $result;

}


function get_student_current_cgpa_entry(array $data)
{
   $status=array();
	$status['has_error']=0;
	$status['error_message']='';
	$status['has_record']=0;
	$status['current_result']=array();
    global $connect;
	$std_id=(isset($data['student_id']))?$data['student_id']:0;
	$level=(isset($data['level_id']))?$data['level_id']:0;
	$semester=(isset($data['semester']))?$data['semester']:'';
	$session_id=(isset($data['session_id']))?$data['session_id']:0;

	//there are parameters that must never be empty
	if(!$std_id||!$level||!$semester||!$session_id)
	{
		//an error
		$status['has_error']=1;
		$status['error_message']="Missing a required parameter for fetching student previous result";
		return $status;
	}
	$sql="SELECT * FROM students_cgpa
        WHERE std_id='%d'
        AND student_level='%d'
        AND student_semester='%s'
        AND session_id='%s'
        LIMIT 1
        ";

     $ret=mysql_query(sprintf($sql,$std_id,$level,$semester,$session_id)) or die(mysql_error());

     if(mysql_num_rows($ret)>0)
     {
     	$status['has_record']=1;
     	//we process the records found
     	while($d=mysql_fetch_assoc($ret))
     	{
			$entry=array();

			$entry['core_courses']=unserialize($d['core_courses']);
			$entry['elective_courses']=unserialize($d['elective_courses']);
			$entry['rcu']=$d['rcu'];
			$entry['trcu']=$d['trcu'];
			$entry['cue']=$d['cue'];
			$entry['tcue']=$d['tcue'];
			$entry['gpa']=$d['gpa'];
			$entry['cgpa']=$d['cgpa'];
			$entry['cur_remark']=$d['remarks'];
			$entry['tcp']=$d['tcp'];
			$entry['ptcp']=$d['ptcp'];
			$entry['student_semester']=$d['student_semester'];
			$entry['student_level']=$d['student_level'];
     	}
     	$status['current_result']=$entry;
     }
     return $status;
}
/**
 * Gets a student's previous results
 *
 * @param array $data
 * @return unknown
 */
function get_student_previous_cgpa_entry(array $data)
{
	$status=array();
	$status['has_error']=0;
	$status['error_message']='';
	$status['has_record']=0;
	$status['previous_result']=array();
    global $connect;
	$std_id=(isset($data['student_id']))?$data['student_id']:0;
	$level=(isset($data['level_id']))?$data['level_id']:0;
	$semester=(isset($data['semester']))?$data['semester']:'';
	$session_id=(isset($data['session_id']))?$data['session_id']:0;

	//there are parameters that must never be empty
	if(!$std_id||!$level||!$semester||!$session_id)
	{
		//an error
		$status['has_error']=1;
		$status['error_message']="Missing a required parameters for fetching student previous result";
		return $status;
	}

   switch(strtolower($semester))
   {
   	case'first semester':
   	  // we need to check  previous session,second semester,at a level 1 less than the current level
   	   if($level>1)
   	   {
   	   	$level=$level-1;
   	   }
   	   if($session_id)
   	   {
   	   	$session_id=$session_id-1;
   	   }
   	   $semester="second semester";

   	break;
   	case'second semester':
   	// we need to check previous semester,same level,same session
   	   $semester="first semester";
   	break;
   }

   $sql="SELECT * FROM students_cgpa
        WHERE std_id='%d'
        AND student_level='%d'
        AND student_semester='%s'
        AND session_id='%s'
        LIMIT 1
        ";

     $ret=mysql_query(sprintf($sql,$std_id,$level,$semester,$session_id)) or die(mysql_error());

     if(mysql_num_rows($ret)>0)
     {
     	$status['has_record']=1;
     	//we process the records found
     	while($d=mysql_fetch_assoc($ret))
     	{
			$entry=array();
			$entry['core_courses']=unserialize($d['core_courses']);
			$entry['elective_courses']=unserialize($d['elective_courses']);
			$entry['prevrcu']=$d['rcu'];
			$entry['prevtrcu']=$d['trcu'];
			$entry['prevcue']=$d['cue'];
			$entry['prevtcue']=$d['tcue'];
			$entry['prevgpa']=$d['gpa'];
			$entry['prevcgpa']=$d['cgpa'];
			$entry['prevremark']=$d['remarks'];
			$entry['probation']=$d['in_probation'];
			$entry['prevtcp']=$d['tcp'];
			$entry['prevptcp']=$d['ptcp'];
     	}
     	$status['previous_result']=$entry;
     }

     return $status;
}

/**
 * Adds a new student cgpa
 * for a given session,semester,level
 *
 * @param array $params
 */
function add_new_cgpa_entry(array $params)
{
    //the student id
    $std_id=(isset($params['student_id']))?$params['student_id']:0;
    //the session id
    $sid=(isset($params['session_id']))?$params['session_id']:0;
    //the level id
    $level=(isset($params['level']))?$params['level']:0;
    //the semester
    $semester=(isset($params['semester']))?$params['semester']:'';
    //the core courses
    $core=(count($params['core_courses'])>0)?$params['core_courses']:array();
    //the elective courses
    $electives=(count($params['elective_courses'])>0)?$params['elective_courses']:array();
    //the cgpa parameters
    $rcu=(isset($params['rcu']))?$params['rcu']:0;
    $trcu=(isset($params['trcu']))?$params['trcu']:0;
    $cue=(isset($params['cue']))?$params['cue']:0;
    $tcue=(isset($params['tcue']))?$params['tcue']:0;
    $gpa=(isset($params['gpa']))?$params['gpa']:0;
    $cgpa=(isset($params['cgpa']))?$params['cgpa']:0;
	$tcp=(isset($params['tcp']))?$params['tcp']:0;
	$ptcp=(isset($params['ptcp']))?$params['ptcp']:0;
    //cast the

    //the probation
    $probation=(isset($params['probation']))?$params['probation']:0;
    //the remarks
    $remarks=(isset($params['remarks']))?$params['remarks']:'';
    //status
    $status=array();
    $status['has_error']=0;
    $status['error_message']='';
    global $connect;
  //check required parameters
  if(!$std_id||!$sid||!$level||!$semester)
  {
     $status['has_error']=1;
     $status['error_message']="Missing required parameters for adding new student cgpa record";
     return $status;
  }

  //we need to encode the core and elective courses
  $core_list=serialize($core);
  $electives_list=serialize($electives);
  $sql="INSERT INTO students_cgpa
         SET
            std_id='%d'
            ,core_courses='%s'
            ,elective_courses='%s'
            ,session_id='%d'
            ,student_level='%d'
            ,student_semester='%s'
            ,rcu='%d'
            ,in_probation='%d'
            ,remarks='%s'
            ,trcu='%d'
            ,cue='%d'
            ,tcue='%d'
            ,gpa='%01.2f'
            ,cgpa='%01.2f'
			,tcp='%d'
			,ptcp='%d'";

      if(!mysql_query(sprintf($sql,$std_id
                              ,$core_list,$electives_list
                              ,$sid,$level,$semester
                              ,$rcu,$probation,$remarks,$trcu,$cue
                              ,$tcue,floatval($gpa),floatval($cgpa),$tcp,$ptcp)))
                              {
                              	//we have an error
                              	$status['has_error']=1;
                              	$status['error_message']=mysql_error();
                              }

      return $status;

}
/**
 * Gets all the carryover a student has
 *  - student_id : the student id
 * @param array $params : an array containing the student id
 * @return array
 */
function get_carryover_courses(array $params)
{ 
   global $connect;
   $results=array();
   $results['has_error']=0;
   $results['error_message']='';
   $results['carry_overs']=array();

   $std_id=(isset($params['student_id']))?$params['student_id']:0;
   if(!$std_id)
   {
   	$results['has_error']=1;
   	$results['error_message']="Missing a required student id for getting the carry overs";
   	return $results;
   }

   $sql="SELECT * FROM students_carryovers
        where std_id='%d'
        LIMIT 1";

      $ret=mysql_query(sprintf($sql,$std_id)) or die(mysql_error());
      if(mysql_num_rows($ret)>0)
      { $d=mysql_fetch_assoc($ret);
         //while($d=mysql_fetch_assoc($ret))
         //{
              $entry=array();
              $entry['student_id']=$std_id;
              $entry['carry_overs']=unserialize($d['carryover']); 
         //}

         $results['carry_overs']=$entry;  
      } 
	  
     return $results;

}

/**
 * Adds a new carryover courses to the system
 * depending on list and what the person already has
 * - student_id : the student id
 * - carry_overs: the student carry over list
 *
 * @param array $params : an array
 * @return array
 */

function add_carryover_courses(array $params)
{
   global $connect;
   $current=array();
   $courses=array();
   $std_id=(isset($params['student_id']))?$params['student_id']:0;
   //the carry over array with keys as course code and value as course object with properties
   $courses=(count($params['carry_overs'])>0)?$params['carry_overs']:array();
   $status=array();
   $status['has_error']=0;
   $status['error_message']='';
   //if there are no carry over to add return
   if(!count($courses))
   {
   	return $status;
   }
  //the student id must be available
    if(!$std_id)
    {
    	$status['has_error']=1;
    	$status['error_message']="Missing a required parameters for adding students carry overs";
    	return $status;
    }
   //ok we have carry overs get previous carry overs if it is available

   $current=get_carryover_courses(array("student_id"=>$std_id)); //var_dump($current);exit;


   $sql_update="UPDATE students_carryovers
           SET carryover='%s'
           WHERE std_id='%d'
           LIMIT 1";

   $sql_add="INSERT INTO
              students_carryovers
             SET std_id='%d'
                ,carryover='%s'";
   //do we have error or a record
   if($current['has_error']!==0)
   {
   	//we have an error in getting a previous carry overs
    $status['has_error']=1;
    $status['error_message']=$current['error_message'];
    return $status;

   }
   //ok check if we have any previous carry overs
   $prev_entry=array();
   //must be an array
   $prev_entry=$current['carry_overs'];
   $entries=array();
   if(!count($prev_entry))
   {
   	//we do not have any previous carry overs so we add this new one
      if(count($courses))
      {
      	if(!mysql_query(sprintf($sql_add,$std_id,serialize($courses))))
      	{
      		$status['has_error']=1;
      		$status['error_message']=mysql_error($connect);
      		return $status;
      	}
      }
   }else
   {
   	//we have previous carry overs
   	//get the list of previous carry overs which is an array with course code as key and course object as value
   	 $entries=$prev_entry['carry_overs'];
     //filter list array holds the final array to be saved
     $filter=array();
     //the duplicate course codes
     $duplicates=array();
     //an array of the previous carry overs course codes
     $prev_course_codes=array();
     //an array of the current carry over course codes
     $curr_course_codes=array();
     //get the key of both previous and current carry overs
     $prev_course_codes=array_keys($entries);
     //the current
     $curr_course_codes=array_keys($courses);
     //check the new carry over course and put into the duplates any course code that also exists in the prev carry overs
    foreach($curr_course_codes as $c)
    {
    	if(in_array($c,$prev_course_codes))
    	{
    		//add to duplicates this course code
    		$duplicates[]=$c;
    	}
    }

    //do we have any duplicate course codes
    if(count($duplicates))
    {
    	//we have duplicates filter it out
        foreach($curr_course_codes as $f)
        {
           if(!in_array($f,$duplicates))
           {
           	//add to filter lists
			 $filter[$f]=$courses[$f];
           }
        }
        //we still need to preserve the previous carry overs

        foreach($prev_course_codes as $s)
        {
        	if(!in_array($s,$duplicates))
        	{
        		$filter[$s]=$entries[$s];
        	}
        }

        //ok so filter is a merge of previous carry over and new carry over
        // and does not contain a carry over twice
    }else
    {
    	//we do not have any duplicates meaning that the carry over are new ones
		foreach($courses as $k=>$val)
		{
			$entries[$k]=$courses[$k];
		}
		//filter will become a merge between the two
		$filter=$entries;
    }
    //we have to update the carry overs table
    //if we do not have any records return
    if(!count($filter))
    {
    	return $status;

    }else if(!mysql_query(sprintf($sql_update,serialize($filter),$std_id),$connect))
    {
    	//we have an error in updating the table
    	$status['has_error']=1;
    	$status['error_message']=mysql_error();
    }
   }

   return $status;
}

/**
 * Update a student carry over records by filtering
 * out those courses that have been cleared by the student
 * from the courses he or she registered
 *  - core_courses: the core courses array of the students with mark and score
 *  - elective_courses : theh elective courses array of the stdudents with mark and score
 *  - student_id : the student id to be processed
 * @param array $params
 * @return array
 */

function update_carryover_courses(array $params)
{ //var_dump($params);exit();
  $core=(count($params['core_courses'])>0)?$params['core_courses']:array();
  $elective=(count($params['elective_courses'])>0)?$params['elective_courses']:array();
  $id=(isset($params['student_id']))?$params['student_id']:0;

  global $connect;

  $filter=array();
  //temporarily holds the list of courses code to be cleared from the carry over log
  $toclear=array();
  $carries=array();
  $status=array();
  $status['has_error']=0;
  $status['error_message']='';
  //if we do not have a student id we fail
  if(!$id)
  {
     $status['has_error']=1;
     $status['error_message']="Missing student id for updating carry over logs";
     return $status;
  }

  //if we have either a core or elective courses ,check if we have
  //any carry over registered against this person's name
  if(count($core)||count($elective))
  {
  	$carries=get_carryover_courses(array("student_id"=>$id)); //echo $id; var_dump($carries);exit();
  }
   //if we do not have any carry over list we simple return
   if($carries['has_error']!==0)
   {
   	  //we have an error in gettingthe student's carry overs
   	  $status['has_error']=1;
   	  $status['error_message']=$carries['error_message'];
   	  return $status;
   }

   //ok check if we have any carry overs for this students
   $lists=array();
   $lists=$carries['carry_overs']; //var_dump($lists);exit();
   //if we do not have any carry overs we simple return
   if(!count($lists))
   {
   	 return $status;
   }

   //ok we have a record,check if we have a carry over
  $carry_lists=array();
  $carry_lists=$lists['carry_overs']; //var_dump($carry_lists);exit();
  //do we have something
  if(!count($carry_lists))
  {
  	return $status;
  }
  //ok we have a carry over list for this student we need to process it
  /**
   * By processing i mean looking through all the regieterd
   * carry overs and removing the ones the student has cleared
   * from either the core or elective courses then updating the
   * carry oever entry with the remaining ones
   */
//var_dump($core);exit();
   //loop through the core courses and add the coursecode and score in the filter array
   if(count($core))
   {
      foreach($core as $c)
      {
       $filter[$c->courseCode]=(int)$c->score;
      }
   }

   //loop through the elective courses and add the coursecode and score in the array
   if(count($elective))
   {
   	  foreach($elective as $s)
     {
       $filter[$s->courseCode]=(int)$s->score;
     }
   }
//var_dump($filter);exit();
   //if we do not have anything in the filter return
   if(!count($filter))
   {
   	 return $status;
   }

   //ok we have the records in the filter now work through the logged carry over search for
   //those course code that are in the filter,if found check the current score if
    // its above 40, if it is put it in the cleared array for later removal from the carry over lists
    $temp_carrylist=array();

    $carry_keys=array_keys($carry_lists); //var_dump($carry_keys);exit();

    foreach ($carry_keys as $k)
    {
       if(array_key_exists($k,$filter))
       {
            //ok we found the coursecode in the filetr check the score
            $score=0;
            $score=(int)$filter[$k]; //var_dump($score);exit();
            //if the score is less than 40 add it to the temp list
            if($score<40)
            {
            	//the course is still failed
            	$temp_carrylist[$k]=$carry_lists[$k]; //var_dump($temp_carrylist[$k]);exit();
            }else
            {	
            	continue;
            }

       }else
       {
       	    //add to the carry list again
            $temp_carrylist[$k]=$carry_lists[$k];
       }
    }
//var_dump($temp_carrylist);exit();
    //In the end what we have in temp_carrylist is a new array containing
    //list of carry over that are still pending to be cleared by the student
    //if we have records in temp_carry list we update the carry over log table
    if(count($temp_carrylist))
    {
    	$sql="UPDATE students_carryovers
    	      SET carryover='%s'
    	      WHERE std_id='%d'
    	      LIMIT 1";

          if(!mysql_query(sprintf($sql,serialize($temp_carrylist),$id),$connect))
          {
          	//we have an error in updating the records
             $status['has_error']=1;
             $status['error_message']="Failed to update the carry over course entries for $id";
             return $status;
          }else
          {
          	return $status;
          }
    }else
    { $sql="UPDATE students_carryovers
    	      SET carryover='%s'
    	      WHERE std_id='%d'
    	      LIMIT 1";

          if(!mysql_query(sprintf($sql,serialize($temp_carrylist),$id),$connect))
          {
          	//we have an error in updating the records
             $status['has_error']=1;
             $status['error_message']="Failed to update the carry over course entries for $id";
             return $status;
          }else
          {
          	return $status;
          }
		
    	return $status;
    }



}
/**
 * Process a single students result and stores it
 * - student_id : the student id
 * - semester : the current semester
 * - level_id : the student current level
 * - session_id : the current session id
 *
 *
 * @param array $params
 * @return array
 */
function process_a_student_resultold(array $params)
{
     $std_id=(isset($params['student_id']))?$params['student_id']:0;
     $semester=(isset($params['semester']))?$params['semester']:'';
     $lid=(isset($params['level_id']))?$params['level_id']:0;
     $sid=(isset($params['session_id']))?$params['session_id']:0;
     $result=array();
     $result['has_error']=0;
     $result['error_message']='';
     $result['is_processed']=0;
     //there are required parameters
     if(!$std_id||!$semester||!$lid||!$sid)
     {
     	$result['has_error']=1;
     	$result['error_message']="Missing required parameters for process result";
     	return $result;
     }
     //the courses the students registered
     $courses=array();
    $courses=get_student_registered_courses(array(
    											"student_id"=>$std_id,
    											"semester"=>$semester,
    											"session_id"=>$sid
                                                ));

     //do we have any result or error
     if($courses['has_error']!==0)
     {
       $result['has_error']=1;
       $result['error_message']=$courses['error_message'];
       return $result;
     }
     //check if we have any courses
     if(!count($courses['courses']))
     {
		//TODO we need to figure out what to do
		return $result;
     }
     //get the courses id and the total registered credit units
     $rcu=0;
     $courseIds=array();
     $courseList=$courses['courses'];
     foreach($courseList as $c)
     {
     	$rcu+=(int)$c->courseUnit;
     	$courseIds[]=(int)$c->courseId;
     }
     //ok we need to get the course this student sat for in exams
     $satfor=array();
     $satfor=get_sat_for_courses(array("student_id"=>$std_id,
                                       "semester"=>$semester,
                                       "session_id"=>$sid,
                                       "course_ids"=>$courseIds));
       //do we have any result so far
       if($satfor['has_error']!==0)
       {
			$result['has_error']=1;
			$result['error_message']=$satfor['error_message'];
			return $result;
       }
      //the examined courses
      $examined=array();
      //the repeat courses
      $repeats=array();
      $examined=$satfor['examined'];
      $repeats=$satfor['repeat'];
      //the current total earned credit units
      $ctcue=0;
      $ctcue=$satfor['ecu'];
      //the total earned credit units so far (previous + current)
      $tcue=0;
      //the total regieterd credit units so far (previous  + current)
      $trcu=0;
      //the total credit points
      $tcp=0;
      $tcp=$satfor['cp'];
      //the previous cgpa records
      $prev=array();
      //previous total registered credit units
      $prevtrcu=0;
      //the previous cgpa
      $prevcgpa=0;
      //the previous total earned units
      $prevtcue=0;
      //the current grade point average
      $gpa=0;
      //the commulative grade point average
      $cgpa=0;

      $prev=get_student_previous_cgpa_entry(array("student_id"=>$std_id
                                                 ,"session_id"=>$sid
                                                 ,"level"=>$lid
                                                 ,"semester"=>$semester));
       //do we have a result or error
       if($prev['has_error']!==0)
       {
       	//we have error
          $result['has_error']=1;
          $result['error_message']=$prev['error_message'];
          return $result;
       }
       //get the entries if it is there
       $prevResult=array();
       //if we have any record get it
       if($prev['has_record']==1)
       {
       	$prevResult=$prev['previous_result'];
       	//the previous total registered credit units
       	$prevtrcu=$prevResult['prevtrcu'];
       	//the previous cgpa
       	$prevcgpa=$prevResult['prevcgpa'];
       	//the previous total earned units
       	$prevtcue=$prevResult['prevtcue'];

       }

       //ok here we do main computation
        //compute the current gpa
        $gpa=compute_gpa(array("tcp"=>$tcp,"rcu"=>$rcu));
        //compute the commulative grade points
        $cgpa=compute_cgpa(array("prevtrcu"=>$prevtrcu,"rcu"=>$rcu,"tcp"=>$tcp,"prevcgpa"=>$prevcgpa));
        //the formatted examined course list
        $formattedList=array();
        //this array has two arrays consisting of core and elective course
        $formattedList=format_core_elective(array("courses"=>$courseList,"examined_courses"=>$examined));
        //format the repeat list courses if we have any for storage
        $formattedRepList=array();
        if(count($repeats))
        {
        	$formattedRepList=format_repeat_courses(array("courses"=>$courseList,"repeats"=>$repeats));
        }
        //the total earned credit units so far
        $tcue=$prevtcue + $ctcue;
        //the total regietered credit units so far
        $trcu=$prevtrcu + $rcu;

        //ok here we add a new entry into the cgpa table
        $add_status=array();
        // create a new or update cgpa entry
        $add_status=create_cgpa_entry(array(
                                             "student_id"=>$std_id,
                                             "core_courses"=>$formattedList['core'],
                                             "elective_courses"=>$formattedList['elective'],
                                             "student_level"=>$lid,
                                             "session_id"=>$sid,
                                             "semester"=>$semester,
                                             "carry_overs"=>$formattedRepList,
                                             "rcu"=>$rcu,
                                             "trcu"=>$trcu,
                                             "cue"=>$ctcue,
                                             "tcue"=>$tcue,
                                             "gpa"=>$gpa,
                                             "cgpa"=>$cgpa
                                            ));

     if($add_status['has_error']!==0)
     {
     	//we have an error
     	$result['has_error']=1;
     	$result['error_message']=$add_status['error_message'];
     	//return $result;

     }else
     {
     	$result['is_processed']=1;
     }
     return $result;

     //TODO : we could do further processing here
}

function process_a_student_result(array $params)
{
    $std_id=(isset($params['student_id']))?$params['student_id']:0;
     $semester=(isset($params['semester']))?$params['semester']:'';
     $lid=(isset($params['level_id']))?$params['level_id']:0;
     $sid=(isset($params['session_id']))?$params['session_id']:0;
     $result=array();
     $result['has_error']=0;
     $result['error_message']='';
     $result['is_processed']=0;
     //there are required parameters
     if(!$std_id||!$semester||!$lid||!$sid)
     {
     	$result['has_error']=1;
     	$result['error_message']="Missing required parameters for processing this student result";
     	return $result;
     }
     //the courses the students registered for the current semester
     $courses=array();
     $courses=get_student_registered_courses(array(
    											"student_id"=>$std_id,
    											"semester"=>$semester,
    											"session_id"=>$sid
                                                ));

     //do we have any result or error
     if($courses['has_error']!==0)
     {
       $result['has_error']=1;
       $result['error_message']=$courses['error_message'];
       return $result;
     }
     //check if we have any courses
     if(!count($courses['courses']))
     {
		//TODO we need to figure out what to do
		return $result;
     }
     //get the courses id and the total registered credit units
     $rcu=0;
     //an array of the courses id
     $courseIds=array();
	 //the courses
     $courseList=$courses['courses'];
     //extracting courses id and summing the registered credit units
     foreach($courseList as $c)
     {
     	$rcu+=(int)$c->courseUnit;
     	$courseIds[]=(int)$c->courseId;
     }
     //ok we need to get the course this student sat for in exams
     $satfor=array();
     $satfor=get_sat_for_courses(array("student_id"=>$std_id,
                                       "semester"=>$semester,
                                       "session_id"=>$sid,
                                       "course_ids"=>$courseIds));//var_dump($satfor);exit;
       //do we have any result so far
       if($satfor['has_error']!==0)
       {
			$result['has_error']=1;
			$result['error_message']=$satfor['error_message'];
			return $result;
       }

       if($satfor['has_record']==0)
       {
       	 return $result;
       }
      //the examined courses
      $examined=array();
      //the repeat courses
      $repeats=array();
      //an array of all the courses the student wrote exams for with scores
      $examined=$satfor['examined'];
      //an array of all the courses the student failed
      $repeats=$satfor['repeat'];
	  //start calculation here
      //some initialization

      //the previous probation
      $prev_probation=0;
      //the previous total registered creedit units
      $prev_trcu=0;
	  $prev_rcu=0;
      //the previous total credit units earned
      $prev_tcue=0;
      //the previous remarks
      $prev_remarks='';
      //the previous cgpa
      $prev_cgpa=0;
      //the previous gpa
      $prev_gpa=0;
	  $prev_tcp=0;
       // :for computing current status
       //Holds the sum of (rcu + prev_trcu)
       $trcu=0;
       //The current earned credit unit of the student
       $ecu=0;
       //Holds the sume of (ecu + prev_tcue)
       $tcue=0;
       //the current grade point average
       $gpa=0;
       //the computed current cgpa
       $cgpa=0;
       //the current grade point
       $gp=0;
	   
      //get the previous result of this student
      $prev_entry=array();
      $prev_entry=get_student_previous_cgpa_entry(array("student_id"=>$std_id
                                                 ,"session_id"=>$sid
                                                 ,"level_id"=>$lid
                                                 ,"semester"=>$semester)); //var_dump($prev_entry);exit;
       //do we have a result or error
       if($prev_entry['has_error']!==0)
       {
       	//we have error
          $result['has_error']=1;
          $result['error_message']=$prev_entry['error_message'];
          return $result;
       }
       //ok do we have a record
       $prev_result=array();
       if($prev_entry['has_record']==1)
       {
       	  $prev_result=$prev_entry['previous_result']; //var_dump($prev_result);exit;
          //initialize the previous variables above
          $prev_cgpa=$prev_result['prevcgpa'];
          $prev_gpa=$prev_result['gpa'];
          $prev_remarks=$prev_result['prevremark']; //var_dump($prev_remarks);exit;
 		  $prev_probation=(int)$prev_result['probation'];
 		  $prev_tcue=(int)$prev_result['prevtcue'];
 		  $prev_trcu=(int)$prev_result['prevtrcu'];
		  $prev_tcp=(int)$prev_result['prevtcp'];
		  $prev_ptcp=(int)$prev_result['prevptcp'];
		  $prev_rcu = (int)$prev_result['prevrcu'];
		  $prev_tcp = $prev_ptcp + $satfor['cp'];
       } 
	   
	   if($prev_entry['has_record']!==1)
       {	   
	   $prev_tcp=$satfor['cp'];
	   }
	   
//var_dump($prev_tcp);//exit;
        //the current status of this student result
         $trcu=$prev_trcu + $rcu; //var_dump($trcu);exit;
         //current enarned credit units
         $ecu=$satfor['ecu'];

         $tcue=$prev_tcue + $ecu; //var_dump($tcue);exit;

         //grade point
         $gp=$satfor['cp'];

         //calculate the grade point average
         $gpa=compute_gpa(array("rcu"=>$rcu,"gp"=>$gp));
         //compute the cummulative grade point average
         $cgpa=compute_cgpa(array("rcu"=>$rcu,"gp"=>$gp,"prevtrcu"=>$prev_trcu,"prevcgpa"=>$prev_cgpa));
         //ok check if we have a previous remark
         if(strlen($prev_remarks)>0)
         {
         	if($prev_remarks=="Pass")
         	{
         		$prev_remarks="";
         	}
         }
         //the current remarks
         $curr_remarks="";
         //format the examined courses list into core and elective
         $formatted_list=array();

         //this array has two arrays consisting of core and elective course
        $formatted_list=format_core_elective(array("courses"=>$courseList,"examined_courses"=>$examined));
        //format the repeat course list into array and string format
        $formatted_repeat_list=array();
        $new_repeats=array();
        //do we have any repeat list
        if(count($repeats))
        {
        	//this will return an array with two array entries ,formatted and stringified
        	$formatted_repeat_list=format_repeat_courses(array("courses"=>$courseList,"repeats"=>$repeats));
        	//a list of course codes to be list in the remarks
        	$curr_remarks=(count($formatted_repeat_list['stringified'])>0)?join(",",$formatted_repeat_list['stringified']):"";
        	//an array of repeat courses
        	$new_repeats=$formatted_repeat_list['formatted'];

        }

        //if the current cgpa is greater than 1
        if($cgpa>=1)
        {
        	//reset the probation
        	$prev_probation=0;
        }else
        {
        	//increase it by 1
        	$prev_probation+=1;
        }
        //check this student probation status
        $curr_remarks=check_probation(array("remarks"=>$curr_remarks
                                           ,"cgpa"=>$cgpa
                                           ,"probation_level"=>$prev_probation));

        //if this student is in 400 level and the semester is second semester check his degree in class

        if(($lid==4 && $semester=="Second Semester")||$lid==5)
        {
        	//get the student graduation level
             	$grad_level=get_student_graduation_level(array("student_id"=>$std_id));
             //build a new remarks for this student
              /*$curr_remarks=compute_student_degree_class(array("remarks"=>$prev_remarks
                                                              ,"cgpa"=>$cgpa
                                                              ,"tcue"=>$tcue
                                                              ,"current_level"=>$lid
                                                              ,"semester"=>$semester
                                                              ,"grad_level"=>$grad_level
                                                              ,"student_id"=>$std_id
                                                              ));*/
        }
		
foreach($new_repeats as $c)
  {
  	$p=new stdClass();
    $p->courseCode=$c->courseCode;
  }		
$curr_remarks2 = $p->courseCode;	
//var_dump($curr_remarks2);		
if(empty($curr_remarks)){
$curr_remarks = $prev_remarks;
}elseif(empty($prev_remarks)){
$curr_remarks = $curr_remarks;
}else{
$curr_remarks = "$curr_remarks2".","."$prev_remarks";
}	
//var_dump($curr_remarks);//exit;

        //save the computed records
        // create a new or update cgpa entry
        $add_status=create_cgpa_entry(array(
                                             "student_id"=>$std_id,
                                             "core_courses"=>$formatted_list['core'],
                                             "elective_courses"=>$formatted_list['elective'],
                                             "student_level"=>$lid,
                                             "session_id"=>$sid,
                                             "semester"=>$semester,
                                             "carry_overs"=>$new_repeats,
                                             "rcu"=>$rcu,
                                             "trcu"=>$trcu,
                                             "cue"=>$ecu,
                                             "tcue"=>$tcue,
                                             "gpa"=>floatval($gpa),
                                             "student_probation"=>$prev_probation,
                                             "remarks"=>$curr_remarks,
                                             "cgpa"=>floatval($cgpa),
											 "tcp"=>$gp,
											 "ptcp"=>$prev_tcp
                                            )); 

     if($add_status['has_error']!==0)
     {
     	//we have an error
     	$result['has_error']=1;
     	$result['error_message']=$add_status['error_message'];


     }else
     {
     	$result['is_processed']=1;
     }
 return $result;
}

/**
 * Get the courses as well as the grades
 * a student sat for for a given semester
 * and session
 *  - student_id : the student id
 *  - semester : the semester we are dealing with
 *  - session_id : the session we are dealing with
 *  - course_ids : an array of all the course ids the student registered for
 *
 * @param array $params
 * @return array;
 */
function get_sat_for_courses(array $params)
{
   $std_id=(isset($params['student_id']))?$params['student_id']:0;
   $semester=(isset($params['semester']))?$params['semester']:'';
   $sid=(isset($params['session_id']))?$params['session_id']:0;
   $cid=(count($params['course_ids'])>0)?$params['course_ids']:array();
   $result=array();
   $result['has_error']=0;
   $result['error_message']='';
   $result['has_record']=0;
   $result['examined']=array();
   $result['cp']=0;
   $result['ecu']=0;
   $result['repeat']=array();

   global $connect;

   //the total earned credit units
   $ecu=0;
   //the total credit point
   $cp=0;
   $cid=array_unique($cid);
   //none of the above should be missing
   if(!$std_id||!$semester||!$sid||!count($cid))
   {
   	  $result['has_error']=1;
   	  $result['error_message']="Missing required parameters for fetching courses sat for";
   	  return $result;
   }


$sqly="SELECT DISTINCT 
	       r.std_mark
	       ,SUM( r.cp) as total
	       FROM students_results AS r
	       
	       WHERE 
	       r.std_id='$std_id'
	       AND r.std_mark_custom1='$semester'
	       AND r.std_mark_custom2='$sid'";

    $rety=mysql_query($sqly) or die(mysql_error());
    
      $d1=mysql_fetch_assoc($rety);
	//echo $std_id ; var_dump($d1['total']); echo'<br>';



   //the query
   $sql="SELECT DISTINCT
	       r.std_mark
	       ,r.std_grade
	       ,c.thecourse_id
	       ,r.cu
	       ,r.cp
	       ,r.ca_status
	       ,r.exam_status
	       ,c.stdcourse_custom2
	       FROM students_results AS r
	        INNER JOIN course_reg AS c
	        ON c.thecourse_id=r.stdcourse_id
	       WHERE r.stdcourse_id IN (%s)
	       AND r.std_id='%d'
	       AND r.std_mark_custom1='%s'
	       AND r.std_mark_custom2='%s'";
		   
    $ret=mysql_query(sprintf($sql,implode(",",$cid),$std_id,$semester,$sid));
    if(mysql_num_rows($ret)>0)
    {
      //we process the result
      $result['has_record']=1;
      $examined=array();
      $repeat=array();
      while($d=mysql_fetch_assoc($ret))
      {
             $cp+=$d['cp'];
			 $p=new stdClass();
	  	  	 $mark=intval($d['std_mark'])."-".$d['std_grade']."";
	  	  	 //the earned credit unit
	  	  	 // I a also checking the ca and exam status if any of them is zero we do not add execute this
	  	  	 if($d['ca_status'] && $d['exam_status'] && ($d['std_mark']>=40))
	  	  	 {
				$ecu+=(int)$d['cu'];
	  	  	 }
	  	  	 //we are modifying this to enable filtering repeat course lists
             $p->mark=$d['stdcourse_custom2']." ".$mark;
             $p->score=$d['std_mark'];
             $p->grade=$d['std_grade'];
             //keep track of the ca and exam status too for later use
             $p->ca_status=$d['ca_status'];
             $p->exam_status=$d['exam_status'];
             $p->cp=$d['cp'];
	  	  	 //$examined[$d['stdcourse_custom2']]=$mark;
               $examined[$d['stdcourse_custom2']]=$p;

	  	  	 if($d['std_grade']=='F')
	  	  	 {
	  	  	 	$repeat[$d['thecourse_id']]=$d['stdcourse_custom2'];
	  	  	 }
      }

      //ok we have a result
      $result['ecu']=$ecu;//echo'<br>';
   // $result['cp']=$cp;
	$result['cp'] = $d1['total'];//echo $result['cp'];
      $result['repeat']=$repeat; //var_dump($repeat);
      $result['examined']=$examined;

    }
    return $result;

}
/**
 * Format the repeat course for storage purpose
 * - courses : the list of registered courses of a students
 * - repeats : the list of repeat courses of a student
 * @param array $params
 * @return array
 */
function format_repeat_courses(array $params)
{
	$courses=(count($params['courses'])>0)?$params['courses']:array();
	$repeats=(count($params['repeats'])>0)?$params['repeats']:array();
    //if any of these is not available return emoty array
    $processed=array();
    $string_format=array();
    $status=array();
    $status['formatted']=array();
    $status['stringified']=array();
    if(!count($courses)||!count($repeats))
    {
    	//return $processed;
    	return $status;
    }

    //get the keys of the repeat courses which is the course ids
    $keys=array_keys($repeats);
     //loop through the courses list and find any one in the repeat list
     foreach($courses as $c)
     {
     	$id=(int)$c->courseId;
     	if(in_array($id,$keys))
     	{
     		//put store as object in the process array taking note which semester the course belong
     		//$p=new stdClass();
			//$p->courseCode=$c->courseCode;
			//$p->courseSemester=$c->course
			$processed[$c->courseCode]=$c; //var_dump($processed);
			$string_format[]=$c->courseCode;
     	}
     }
      $status['formatted']=$processed;
      $status['stringified']=$string_format;
     //return $processed;
     return $status;

}

/**
 * Format courses into core or elective
 * - examined_courses : the examined courses with marks
 * - courses : the courses the student registered
 * @param array $params
 * @return array
 */
function format_core_elective(array $params)
{
  $examined=(count($params['examined_courses'])>0)?$params['examined_courses']:array();
  $courses=(count($params['courses'])>0)?$params['courses']:array();
  $processed=array();
  $processed['core']=array();
  $processed['elective']=array();
  $cores=array();
  $electives=array();
  //if any one of them is empty return empty array
  if(!count($courses)||!count($examined))
  {
  	return $processed;
  }
  //loop through the registered courses and find the mark on examined course list
  //anyone missing in examined that means that the student regietered the course
  //but did not sit for it in exam,strange
  foreach($courses as $c)
  {
  	$p=new stdClass();

        $p->courseCode=$c->courseCode;
        $p->courseSemester=$c->semester;
        $p->courseType=$c->courseType;
        $p->courseName=$c->courseName;
        $p->courseUnit=$c->courseUnit;
	$p->courseLevel=$c->courseLevel;

  	if(array_key_exists($c->courseCode,$examined))
  	{
      //we found it in the examined array
        //$p->mark=$examined[$c->courseCode];
        $cc=$examined[$c->courseCode];
        $p->mark=$cc->mark;
        $p->score=$cc->score;
        $p->grade=$cc->grade;
        $p->cp=$cc->cp;
  	}else
  	{
  		$p->mark=$c->courseCode."-"."ABS";
  		$p->score=0;
  		$p->grade='?';
  		$p->cp=0;

  	}

  	//what type of course core or elective
  	if($c->courseType=='core')
  	{
  		$cores[]=$p;
  	}else
  	{
  		$electives[]=$p;
  	}
  	//$processed[]=$p;
  }

  $processed['core']=$cores;
  $processed['elective']=$electives;
  return $processed;
}

/**
 * Get the list of students based on a given
 * category
 * - faculty_id : the faculty id of the student list
 * - session_id : the session id to be fetched
 * - department_id : the depertment we are fetching students from
 * - semester : the semester we are interested in
 * - level_id : the student level id we are fetching
 *
 * @param array $params
 * @return unknown
 */
function get_students_based_on_category(array $data)
{ 
    global $connect,$_SESSION;
	$fid=(isset($data['faculty_id']))?$data['faculty_id']:0;
	$sid=(isset($data['session_id']))?$data['session_id']:0;
	$did=(isset($data['department_id']))?$data['department_id']:0;
	$semester=(isset($data['semester']))?$data['semester']:'';
	$lid=(isset($data['level_id']))?$data['level_id']:0;
	$studyid=(isset($data['study_id']))?$data['study_id']:0;
	//$list_type=(isset($data['list_type']))?$data['list_type']:'pass';
	$result=array();
    //if any of those is missing we have a problem
	if(!$sid || !$fid || !$did || !$semester || !$lid||!$studyid)
	{
		return $result;
	}

	$groupID=$_SESSION['groupID'];

	$facultyID=$_SESSION['myfaculty_id'];

	$departmentID=$_SESSION['mydepartment_id'];

	$where="";

	switch($groupID)
	{
		case 13:// PG Dean
		break;
		case 9:// Dean UG
		case 3://Faculty examination officer
		if($did)
		{
			$where="AND p.stddepartment_id='$did'";
		}
		$where.="AND p.stdfaculty_id='$facultyID'";
		
		break;
		case 8://HOD
		case 21://Departmental examination officer
		$where=" AND p.stdfaculty_id='$facultyID'";
		$where.=" AND p.stddepartment_id='$did'";
		break;

		default://Others
		$where="";
		$jq="";
		$jwhere="";
		

		if($did)
		{
			$where="AND p.stddepartment_id='$did'";
		}
		if($fid)
		{
			$where.="AND p.stdfaculty_id='$fid'";
		}
		
		
	}
	

	$sql="SELECT DISTINCT
	         CONCAT(p.surname,' ',p.firstname,' ',p.othernames)
		     AS name
			 ,p.std_id
			 ,p.matric_no
			FROM students_profile AS p
			LEFT JOIN course_reg  AS c
			USING(std_id)
			WHERE c.cyearsession='$sid'
			AND c.csemester='$semester'
			AND c.clevel_id='$lid'
			AND p.stdcourse='$studyid'
			AND p.std_custome1<7
			$where
			
			GROUP BY p.matric_no ORDER BY p.matric_no DESC";
	$res=mysql_query($sql,$connect) or die(mysql_error());
	if(mysql_num_rows($res)>0)
	{
		while($d=mysql_fetch_assoc($res))
		{
			$record=new stdClass();
			$record->studentId=$d['std_id'];
			$record->studentName=$d['name'];
			$record->studentMatricno=$d['matric_no'];
			
			$result[]=$record;
		}
	} //var_dump($result);exit;
	return $result;
}

/**
 * Checks is a category result has been processed
 *  - faculty_id : the faculty we are dealing with
 *  - department_id : the department we are dealing
 *  - level_id : the level id we are dealing with
 *  - semester : the current semester we are dealing with
 *  - session_id : the session we are dealing with
 *
 * @param array $params
 * @return bool true if found ,false otherwise
 */
function check_if_result_is_processed(array $params)
{
	global $connect;
	$encoded=array();

	$collections=array("faculty_id",'session_id','semester_id','department_id','level_id','study_id');

  if(!count($params))
  {
  	return false;
  }

  foreach($collections as $c)
    {
    	if(array_key_exists($c,$params))
    	{
    	  $encoded[$c]=$params[$c];
    	}
    }
    ksort($encoded);

  $str='';
  foreach($encoded as $k=>$v)
  {
     $str.=$k."=".$v;
  }
  $code=md5($str);
  //find the process id in the db
  $sql="SELECT * FROM result_process_log
        WHERE process_id='%s'
        LIMIT 1";

    $ret=mysql_query(sprintf($sql,$code));
    if(mysql_num_rows($ret)>0)
    {
    	return true;
    }else {
    	return false;
    }
}

/**
 * Updates the result process log table
 *  - faculty_id : the faculty id we are dealing with
 *  - department_id : the department we are dealing with
 *  - level_id : the level we are dealing with
 *  - semester : the semester we are dealing with
 *  - session_id : the session we are dealing
 *
 * @param array $params
 * @return bool true on success
 */
function update_result_process_log(array $params)
{
	global $connect;
    $encoded=array();
	$collections=array("faculty_id",'session_id','semester_id','department_id','level_id','study_id');

    if(!count($params))
    {
    	return false;
    }
    //we need to make sure that the content of the array are ordered
    foreach($collections as $c)
    {
    	if(array_key_exists($c,$params))
    	{
    	  $encoded[$c]=$params[$c];
    	}
    }
    ksort($encoded);
    // construct a string from the content of this
    $str='';
    foreach($encoded as $k=>$v)
    {

    	$str.=$k."=".$v;
    }
    $code=md5($str);
   $sql="INSERT IGNORE INTO result_process_log
         SET process_id='%s'";
       $ret=mysql_query(sprintf($sql,$code)) or die(mysql_error());
       return true;
}

/**
 * We are doing the result processing based on a given
 * criteria
 *  - session_id : the session id for which we are processing result for
 *  - faculty_id : the faculty id we are processing
 *  - department_id : the department id we are processing
 *  - semester_id : the semester we are dealing with
 *  - level_id : the level id we are dealing with
 *  - is_redoing : whether we are redoing the result processing or not
 *
 * @param array $params
 */
function do_result_processing(array $params)
{
   $fid=(isset($params['faculty_id']))?$params['faculty_id']:0;
   $did=(isset($params['department_id']))?$params['department_id']:0;
   $sid=(isset($params['session_id']))?$params['session_id']:0;
   $semester=(isset($params['semester_id']))?$params['semester_id']:'';
   $levelId=(isset($params['level_id']))?$params['level_id']:0;
   $studyid=(isset($params['study_id']))?$params['study_id']:0;
   $redoing=(isset($params['is_redoing']))?$params['is_redoing']:0;

   $status=array();
   $status['has_error']=0;
   $status['error_message'];
   $status['has_records']=0;
   $status['processed_count']='';

   $process_count=0;
   //the student id list
   $id_lists=array();
   global $connect,$_SESSION;

   $group_id=$_SESSION['groupID'];
   $sess_faculty_id=$_SESSION['myfaculty_id'];
   $sess_department_id=$_SESSION['mydepartment_id'];

   $where='';

   switch($group_id)
   {
   	case 13 : //the pg dean
   	break;
   	case 9 : //the dean undergraduate
   	case 3://Faculty examination officer
       $where="AND p.stddepartment_id='$did'";
       $where.=" AND stdfaculty_id='$sess_faculty_id'";
       break;
   	case 8: //HOD head of departments
   	case 21://Departmental examination officer
           $where="AND p.stddepartment_id='$sess_department_id'";
           $where.=" AND p.stdfaculty_id='$sess_faculty_id'";
   	break;
   	default:
      $where="AND p.stddepartment_id='$did' AND p.stdfaculty_id='$fid'";
   }

   $sql="SELECT DISTINCT
	        p.std_id
		 FROM students_profile AS p
	     LEFT JOIN course_reg  AS c
	     USING(std_id)
	     WHERE
	           c.cyearsession='$sid'
			   AND c.csemester='$semester'
			   AND p.stdcourse='$studyid'
			   AND c.clevel_id='$levelId'
			   AND p.std_custome1<7
			   $where";

      $ret=mysql_query($sql,$connect) or die(mysql_error());
      if(mysql_num_rows($ret)>0)
      {
      	//we have a result to process otherwise nothing

      	$status['has_records']=1;

         while($d=mysql_fetch_assoc($ret))
         {
         	array_push($id_lists,$d['std_id']);
         }

         //ok we start processing the each of these students results
         //are we redoing processing
          //set the time limit to zero
          $id_lists=array_unique($id_lists);

          set_time_limit(0);

         	foreach($id_lists as $id)
         	{
         		$temp=process_a_student_result(array(
         											"student_id"=>$id,
         											"level_id"=>$levelId,
         											"semester"=>$semester,
         											"session_id"=>$sid
         		                                     ));
				//if we have any error return it
				if($temp['has_error']!==0)
				{
                  $status['has_error']=1;
                  $status['error_message']=$temp['error_message'];
                  break;
				}else
				{
					if($temp['is_processed'])
					{
					  $process_count++;
					}else
					{
						continue;
					}

				}

         	}
         	//if we have an error so far return
         	if($status['has_error']!==0)
         	{
         		return $status;
         	}
         	//ok if we get to this place we need to check if we are redoing or not
         	if(!$redoing)
         	{
         		//we need to update the result processing log
              update_result_process_log($params);

              //create an entry in the result publishing for this criteria
              create_publish_result_entry(array('faculty_id'=>$fid
                                                ,'department_id'=>$did
                                                ,'programme_id'=>$studyid
                                                ,'level_id'=>$levelId
                                                ,'semester'=>$semester
                                                ,'session_id'=>$sid));
         	}
      }else
      {
         $status['has_error']=1;
         $status['error_message']="There are no student found for this criteria";
      }

      $status['processed_count']=$process_count;
      return $status;
}

function find_student_for_processing(array $params)
{    
	$matno=isset($params['matric_no'])?$params['matric_no']:'';
    $lid=isset($params['level_id'])?$params['level_id']:0;
    $sid=isset($params['session_id'])?$params['session_id']:0;
    $semester=isset($params['semester'])?$params['semester']:'';

    $result=array();
    $result['error_code']=0;
    $result['error_message']='';
    $result['has_record']=0;
    $result['information']=null;
    $result['currresult']=array();
    $result['prevresult']=array();
    $result['rawscore']=array();
   //this field must not be empty
   if(!$matno||!$lid||!$sid||!$semester)
   {
   	 $result['error_code']=1;
   	 $result['error_message']='Missing a required parameter for fetching student information';
   	 return $result;
   }

   //find this student infor
   $check=retrieve_student_information($matno);
   //if we have an error return
   if($check['error_code']!==0)
   {
	  $result['error_code']=1;
	  $result['error_message']=$check['error_message'];
	  return $result;
   }
   //check if we have a result
   if($check['has_record']==0)
   {
   	  $result['error_code']=1;
   	  $result['error_message']="Failed to find record for this student $matno";
   	  return $result;
   }
   //ok we have a record
   $studentObject=$check['data'];

   //next we get the students result for the criteria
   $current=get_student_current_cgpa_entry(array('student_id'=>$studentObject->studentId,
                                                 'semester'=>$semester,
                                                 'session_id'=>$sid,
                                                 'level_id'=>$lid));

   $previous=get_student_previous_cgpa_entry(array('student_id'=>$studentObject->studentId,
                                                    'semester'=>$semester,
                                                    'session_id'=>$sid,
                                                    'level_id'=>$lid));



    //check if we have a record or error
    if($current['has_error']!==0)
    {
    	$result['error_code']=1;
    	$result['error_message']=$current['error_message'];
    	return $result;
    }
    //if we do not have any record return
    if($current['has_record']==0)
    {
    	$result['error_code']=1;
    	$result['error_message']="The are no result record found for $matno";
    	return $result;
    }
    //ok we have cgpa entry
    $entry=array();
    $entry=$current['current_result'];

    //check the previous records
     $prev_entry=array();
     $prev_entry['prevrcu']=0;
     $prev_entry['prevtrcu']=0;
     $prev_entry['prevtcue']=0;
     $prev_entry['prevgpa']=0;
     $prev_entry['prevcgpa']=0;

     //if we have an error return
     if($previous['has_error']!==0)
     {
     	//we have an error
     	$result['error_code']=1;
     	$result['error_message']="An error occured while fetching previous result for $matno";
     	return $result;
     }
    //do we have any record
    if($previous['has_record']>0)
    {
		$prev_entry['prevrcu']=$previous['prevrcu'];
		$prev_entry['prevtrcu']=$previous['prevtrcu'];
		$prev_entry['prevtcue']=$previous['prevtcue'];
		$prev_entry['prevgpa']=$previous['prevgpa'];
		$prev_entry['prevcgpa']=$previous['prevcgpa'];
    }
    //ok we need to get the students raw scores
    $rawscore=get_student_raw_scores(array('student_id'=>$studentObject->studentId,
                                           'level_id'=>$lid,
                                           'session_id'=>$sid,
                                           'semester'=>$semester));
	//var_dump($rawscore);
	//exit;
   //do we have any error
   if($rawscore['error_code']!==0)
   {
   	  $result['error_code']=1;
   	  $result['error_message']=$rawscore['error_message'];
   	  return $result;
   }
   //if we do not have any record return
   if($rawscore['has_record']==0)
   {
   	//no record found for this student
     $result['error_code']=1;
     $result['error_message']="No record found for $matno in result entry";
     return $result;
   }
   //ok we have a result
   $scores=array();
   $scores=$rawscore['data'];
  //ok we have the student infor,result and raw score
  $result['has_record']=1;
  $result['information']=$studentObject;
  $result['rawscore']=$scores;
  $result['currresult']=$entry;
  $result['prevresult']=$prev_entry;
  return $result;
}

function retrieve_student_information($matno='')
{

	$status=array();
	$status['error_code']=0;
	$status['error_message']='';
    $status['has_record']=0;
	global $connect,$_SESSION;

   $group_id=$_SESSION['groupID'];
   $sess_faculty_id=$_SESSION['myfaculty_id'];
   $sess_department_id=$_SESSION['mydepartment_id'];

   $where='';
   switch($group_id)
   {
   	case 13 : //the pg dean
   	break;
   	case 9 : //the dean undergraduate
   	case 3://Faculty Examination Officer
       $where.=" AND stdfaculty_id='$sess_faculty_id'";
       break;
   	case 8: //HOD head of departments
   	case 21://Departmental Examination Officer
           $where="AND p.stddepartment_id='$sess_department_id'";
           $where.=" AND p.stdfaculty_id='$sess_faculty_id'";
   	break;
   	default:
      $where='';
   }

   $sql="SELECT p.std_id
               ,p.matric_no
               ,CONCAT(p.firstname,' ',p.surname) AS name
               ,f.faculties_id
               ,f.faculties_name
               ,d.departments_id
               ,d.departments_name
               ,s.programme_option
          FROM students_profile AS p
               ,faculties AS f
               ,departments AS d
               ,dept_options AS s
          WHERE p.matric_no like '%$matno%'
          AND p.stdfaculty_id=f.faculties_id
          AND p.stddepartment_id=d.departments_id
          AND p.stdcourse=s.do_id
          $where
          LIMIT 1";

    $ret=mysql_query($sql,$connect);

    if(mysql_num_rows($ret)>0)
    {
    	$status['has_record']=1;
       while($d=mysql_fetch_assoc($ret))
       {

         $s=new stdClass();
         $s->studentId=$d['std_id'];
         $s->studentName=$d['name'];
         $s->studentMatricno=$d['matric_no'];
         $s->studentFacultyName=$d['faculties_name'];
         $s->studentFacultyId=$d['faculties_id'];
         $s->studentDepartmentName=$d['departments_name'];
         $s->studentDepartmentId=$d['departments_id'];
         $s->studentProgramme=$d['programme_option'];
       }
       $status['data']=$s;
    }

    return $status;
}

function get_student_raw_scores(array $params)
{ 
   $id=isset($params['student_id'])?$params['student_id']:0;
   $lid=isset($params['level_id'])?$params['level_id']:0;
   $sid=isset($params['session_id'])?$params['session_id']:0;
   $semester=isset($params['semester'])?$params['semester']:'';
   $status=array();
   $status['error_code']=0;
   $status['error_message']='';
   $status['data']=array();
   $status['has_record']=0;

   global $connect;
   //if any of the fields are missing it's an error
   if(!$id||!$lid||!$sid||!$semester)
   {
      $status['error_code']=1;
      $status['error_message']='Missing required field for fetching the student raw score';
      return $status;
   }
   //ok the query
   $studyid=get_student_info($id,'stdcourse');

   $sql="SELECT DISTINCT r.stdcourse_id
   				,c.course_code
                ,r.std_ca
                ,r.std_exam
                ,r.ca_status
                ,r.exam_status
                ,r.std_mark
                ,r.std_grade
         FROM students_results AS r,
              all_courses AS c

         WHERE r.std_id='$id'
         AND r.level_id='$lid'
         AND r.std_mark_custom1='$semester'
         AND r.std_mark_custom2='$sid'
         AND c.course_custom2='$studyid'
         AND r.stdcourse_id=c.thecourse_id";

   $ret=mysql_query($sql,$connect);
   $temp=array();
   if(mysql_num_rows($ret)>0)
   {
     $status['has_record']=1;
     while($d=mysql_fetch_assoc($ret))
     {
		$s=array();
		$s['courseCode']=$d['course_code'];
		$s['caScore']=$d['std_ca'];
		$s['caStatus']=$d['ca_status'];
		$s['examStatus']=$d['exam_status'];
		$s['examScore']=$d['std_exam'];
		$s['courseId']=$d['stdcourse_id'];
		$s['mark']=$d['std_mark'];
		$s['grade']=$d['std_grade'];
        $temp[]=$s;
     }
     $status['data']=$temp;
   }
   return $status;
}

function list_unreleased_results(array $params)
{

	$ses=isset($params['session_id'])?$params['session_id']:0;
	$lid=isset($params['level_id'])?$params['level_id']:0;
	$semester=isset($params['semester'])?$params['semester']:'';
	$did=isset($params['department_id'])?$params['department_id']:0;
	$fid=isset($params['faculty_id'])?$params['faculty_id']:0;
	$sid=isset($params['study_id'])?$params['study_id']:0;

	$status=array();
	$status['error_code']=0;
	$status['error_message']='';
	$status['data']=array();
	$students=array();
    //keys that must not be empty
if(!$did||!$fid||!$ses||!$semester||!$lid||!$sid)
{//var_dump($_SESSION['QueryData']);exit;
	if(isset($_SESSION['QueryData'])){
       $params2 = unserialize($_SESSION['QueryData']);
         $did = intval($params2->departmentId);
          $fid =  intval($params2->facultyId);
          $ses =  intval($params2->sessionId);
         $sid =  intval($params2->studyId);
			$lid = intval($params2->levelId);
			$semester = $_SESSION['semester'];
			}
			
	//$status['error_code']=1;
   //$status['error_message']='You have incomplete parameters for fetching requested list';
   //return $status;
}
    global $connect;
    global $pager;
	$groupID=$_SESSION['groupID'];
	$facultyID=$_SESSION['myfaculty_id'];
	$departmentID=$_SESSION['mydepartment_id'];

	$where="";

	switch($groupID)
	{
		case 13:// PG Dean
		break;
		case 9:// Dean UG
		case 3://Faculty examination officer
			$where="AND p.stddepartment_id='$did'";
		    $where.="AND p.stdfaculty_id='$facultyID'";
		break;
		case 8://HOD
		case 21://Departmental examination officer
		  $where="AND p.stdfaculty_id='$facultyID'";
		  $where.="AND p.stddepartment_id='$departmentID'";
		  break;
		  default://Others
		  $where="";
		  $where="AND p.stdfaculty_id='$fid'";
		  $where.="AND p.stddepartment_id='$did'";
	}
    //initialize the paginator
	$pager->setRows($students);
	$sql="SELECT
		    CONCAT(p.surname,' ',p.firstname,' ',p.othernames) AS name
		    ,p.std_id
			,p.matric_no
            ,d.departments_name
            ,f.faculties_name
            ,t.programme_option
			,r.id
			FROM unreleased_results AS r
			      LEFT JOIN students_profile AS p
			         ON p.std_id=r.student_id
			          LEFT JOIN faculties  AS f
			         ON f.faculties_id=p.stdfaculty_id
                      LEFT JOIN departments AS d
                       ON d.departments_id=p.stddepartment_id
                        LEFT JOIN dept_options AS t
                         ON t.do_id=p.stdcourse
			          WHERE r.semester='$semester'
			          AND r.study_id='$sid'
			           AND r.level_id='$lid'
			          $where
			          GROUP BY p.matric_no ORDER BY p.surname,p.firstname";


	  $res =mysql_query($sql,$connect) or die(mysql_error());
       if(mysql_num_rows($res)>0)
       {
           while($d=mysql_fetch_assoc($res))
           {
               $s=new stdClass();
               $s->studentName=$d['name'];
               $s->releaseId=$d['id'];
               $s->studentId=$d['std_id'];
               $s->studentFaculty=$d['faculties_name'];
               $s->studentDepartment=$d['departments_name'];
               $s->studentProgramme=$d['programme_option'];
               $s->studentMatricno=$d['matric_no'];
               $students[]=$s;
           }
       }
       $pager->setRows($students);

       $status['data']=$students;

       return $status;
}

function find_students_to_withhold_result($params)
{  
  $ses=isset($params['session_id'])?$params['session_id']:0;
	$lid=isset($params['level_id'])?$params['level_id']:0;
	$semester=isset($params['semester'])?$params['semester']:'';
	$did=isset($params['department_id'])?$params['department_id']:0;
	$fid=isset($params['faculty_id'])?$params['faculty_id']:0;
	$sid=isset($params['study_id'])?$params['study_id']:0;

	$status=array();
	$status['error_code']=0;
	$status['error_message']='';
	$status['data']=array();
	$students=array();
	
	
	
	
	
if(!$did||!$fid||!$ses||!$semester||!$lid||!$sid)
{  

  if(isset($_SESSION['QueryData'])){
       $params2 = unserialize($_SESSION['QueryData']);
         $did = intval($params2->departmentId);
          $fid =  intval($params2->facultyId);
          $ses =  intval($params2->sessionId);
         $sid=  intval($params2->studyId);
			$lid = intval($params2->levelId);
			$sid = ($params2->semester);}
   			//$status['error_code']=1;
   			//$status['error_message']='You have incomplete parameters for fetching requested list';
   			//return $status;
}

     $string = unrealese_id ($fid,$did,$ses,$semester,$lid,$sid);
	 
    global $connect;
    global $pager;
	$groupID=$_SESSION['groupID'];
	$facultyID=$_SESSION['myfaculty_id'];
	$departmentID=$_SESSION['mydepartment_id'];

	$where="";

	switch($groupID)
	{
		case 13:// PG Dean
		break;
		case 9:// Dean UG
		case 3://Faculty examination officer
			$where="AND p.stddepartment_id='$did'";
		    $where.="AND p.stdfaculty_id='$facultyID'";
		break;
		case 8://HOD
		case 21://Departmental examination officer
		  $where="AND p.stdfaculty_id='$facultyID'";
		  $where.="AND p.stddepartment_id='$departmentID'";
		  break;
		  default://Others
		  $where="";
		  $where="AND p.stdfaculty_id='$fid'";
		  $where.="AND p.stddepartment_id='$did'";
	}
    //initialize the paginator
	$pager->setRows($students);
	$sql="SELECT
		    CONCAT(p.surname,' ',p.firstname,' ',p.othernames) AS name
		    ,p.std_id
			,p.matric_no
            ,d.departments_name
            ,f.faculties_name
            ,t.programme_option
			
			FROM students_profile AS p
			         
			          LEFT JOIN faculties  AS f
			         ON f.faculties_id=p.stdfaculty_id
                      LEFT JOIN departments AS d
                       ON d.departments_id=p.stddepartment_id
                        LEFT JOIN dept_options AS t
                         ON t.do_id=p.stdcourse
			          WHERE 
			          p.stdcourse='$sid'
					  AND p.std_id NOT IN ($string)
			           AND p.std_custome1 ='$lid'
					   AND p.matric_no != p.std_custome9
			          $where
			          GROUP BY p.matric_no ORDER BY p.surname,p.firstname";

      
	  $res =mysql_query($sql,$connect) or die(mysql_error());
       if(mysql_num_rows($res)>0)
       {
           while($d=mysql_fetch_assoc($res))
           {
               $s=new stdClass();
               $s->studentName=$d['name'];
               $s->releaseId=$d['id'];
               $s->studentId=$d['std_id'];
               $s->studentFaculty=$d['faculties_name'];
               $s->studentDepartment=$d['departments_name'];
               $s->studentProgramme=$d['programme_option'];
               $s->studentMatricno=$d['matric_no'];
               $students[]=$s;
           }
       }
       $pager->setRows($students);

       $status['data']=$students;

       return $status;
}

function release_selected_results(array $params)
{
   global $connect;
   $status=array();
   $status['error_code']=0;
   $status['error_message']='';

   if(!count($params))
   {
      $status['error_code']=1;
      $status['error_message']='You have not selected any students results for releasing';
      return $status;
   }
   //ok
    $ids=array();
    $ids=array_values($params);
	$ids = implode(',',$ids);
    $sql= "DELETE FROM unreleased_results WHERE id IN($ids)";
	mysql_query($sql) or die(mysql_error());

    if(count($ids))
    {
         if(!mysql_query(sprintf($sql,$connect)))
         {
			$status['error_code']=1;
			$status['error_message']='Error could not release results '.mysql_error($connect);
			return $status;
         }else
         {
         	$status['error_message']="Selected student's results have been released";
         	return $status;
         }
    }else
    {
    	$status['error_code']=1;
    	$status['error_message']='Error could not find selected students data';
    	return $status;
    }

}




//fetch the unrealease 



function unrealese_id( $fid,$did,$ses,$semester,$lid,$sid){
	
	  global $connect;

$sql_unrelease="SELECT
                             c.student_id
                             ,count(c.student_id) AS total
                        FROM unreleased_results  AS c
                        WHERE c.faculty_id ='$fid'
                        AND c.department_id ='$did' 
						AND c.session_id = '$ses'
						AND c.semester ='$semester'
						AND c.level_id = '$lid' 
						AND c.study_id = '$sid'
						
                        GROUP BY  c.student_id";

	$ret=mysql_query($sql_unrelease,$connect) or die(mysql_error());
	if(mysql_num_rows($ret)>0)
	{
		//we have people who have registered for this session and therefore have paid
		while($d=mysql_fetch_assoc($ret))
		{
			if($d['total']>0)
			{
				$unrelease[]=$d['student_id'];
			}
		}
	}

	if(count($unrelease))
	{
		$unrelease=array_unique($unrelease);
	}else
	{
	  $unrelease[]=0;
	}

	$string=implode(",",$unrelease);
	
	return $string ; 
	}





function withhold_student_result(array $params)
{
  //the session id 

  $ses=isset($params['session_id'])?$params['session_id']:0;
  $lid=isset($params['level_id'])?$params['level_id']:0;
  $sid=isset($params['study_id'])?$params['study_id']:0;
  $fid=isset($params['faculty_id'])?$params['faculty_id']:0;
  $did=isset($params['department_id'])?$params['department_id']:0;
  $sem=isset($params['semester'])?$params['semester']:'';
  $lists=(count($params['students'])>0)?$params['students']:array();
  $semester = $_SESSION['semester'];
  
 
  

  global $connect;
  //the key parameters must be available
  $status=array();
  $status['error_code']=0;
  $status['error_message']='';
  
  
  //store query for persistence
  
			
  if(!$ses||!$lid||!$sid||!$fid||!$did)
  {
	  
	  if(isset($_SESSION['QueryData'])){
       $params2 = unserialize($_SESSION['QueryData']);
         $did = intval($params2->departmentId);
          $fid =  intval($params2->facultyId);
          $ses =  intval($params2->sessionId);
         $sid=  intval($params2->studyId);
			$lid = intval($params2->levelId);
			$sid = ($params2->semester);}
  //	$status['error_code']=1;
  //	$status['error_message']='Incomplete information supplied for perform this action';
  }

  $sql="INSERT INTO unreleased_results
        SET
           student_id='%d'
           ,faculty_id='%d'
           ,department_id='%d'
           ,study_id='%d'
           ,semester='%s'
           ,session_id='%d'
           ,level_id='%d'";
		  

    if(count($lists))
    {
       foreach($lists as $id)
       {
         if(!mysql_query(sprintf($sql,$id,$fid,$did,$sid,$semester,$ses,$lid),$connect))
         {
			$status['error_code']=1;
			$status['error_message']='Error,failed to process '.mysql_error($connect);
			break;
         }
       }

       $status['error_message']='The selected '.count($lists).' student result has been unpublished';
    }
return $status;

}
function get_courseCode_based_on_category($fid,$did,$semester,$lid,$studyid,$sid)
{
    global $connect,$_SESSION;
	/*$fid=(isset($data['faculty_id']))?$data['faculty_id']:0;
	$sid=(isset($data['session_id']))?$data['session_id']:0;
	$did=(isset($data['department_id']))?$data['department_id']:0;
	$semester=(isset($data['semester']))?$data['semester']:'';
	$lid=(isset($data['level_id']))?$data['level_id']:0;
	$studyid=(isset($data['study_id']))?$data['study_id']:0;
	*/
	$result=array();
    //if any of those is missing we have a problem
	if(!$sid || !$fid || !$did || !$semester || !$lid||!$studyid)
	{
		return $result;
	}

	$groupID=$_SESSION['groupID'];

	$facultyID=$_SESSION['myfaculty_id'];

	$departmentID=$_SESSION['mydepartment_id'];

	$where="";

	switch($groupID)
	{
		case 13:// PG Dean
		break;
		case 9:// Dean UG
		case 3://Faculty examination officer
		if($did)
		{
			$where="AND p.stddepartment_id='$did'";
		}
		$where.="AND p.stdfaculty_id='$facultyID'";
		break;
		case 8://HOD
		case 21://Departmental examination officer
		$where=" AND p.stdfaculty_id='$facultyID'";
		$where.=" AND p.stddepartment_id='$did'";
		break;

		default://Others
		$where="";

		if($did)
		{
			$where="AND p.stddepartment_id='$did'";
		}
		if($fid)
		{
			$where.="AND p.stdfaculty_id='$fid'";
		}
	}

	$sql="SELECT DISTINCT c.stdcourse_custom2, c.c_unit, c.thecourse_id, c.stdcourse_custom1
			FROM students_profile AS p
			LEFT JOIN course_reg  AS c
			     USING(std_id)
			WHERE c.cyearsession='$sid'
			AND c.csemester='$semester'
			AND c.clevel_id='$lid'
			AND p.stdcourse='$studyid'
			AND p.std_custome1<7
			$where
			ORDER BY c.stdcourse_custom2";

	$res=mysql_query($sql,$connect) or die(mysql_error());
	if(mysql_num_rows($res)>0)
	{
		while($d=mysql_fetch_assoc($res))
		{
			$record=new stdClass();
			$record->courseCodeName=$d['stdcourse_custom1'];
			$record->courseCode=$d['stdcourse_custom2'];
			$record->courseCodeUnit=$d['c_unit'];
			$record->courseCodeId=$d['thecourse_id'];
			//$record->studentName=$d['name'];
			//$record->studentMatricno=$d['matric_no'];
			$result[]=$record; 
		}
	}//var_dump($result);exit;
	return $result;
}
function get_courseStatus_based_on_category($std_id,$cid,$semester,$lid,$sid)
{ 
    global $connect,$_SESSION;
	/*$fid=(isset($data['faculty_id']))?$data['faculty_id']:0;
	$sid=(isset($data['session_id']))?$data['session_id']:0;
	$did=(isset($data['department_id']))?$data['department_id']:0;
	$semester=(isset($data['semester']))?$data['semester']:'';
	$lid=(isset($data['level_id']))?$data['level_id']:0;
	$studyid=(isset($data['study_id']))?$data['study_id']:0;
	*/
	$result=array();
    //if any of those is missing we have a problem
	if(!$sid || !$std_id || !$cid || !$semester || !$lid)
	{
		return $result;
	}

	$groupID=$_SESSION['groupID'];

	$facultyID=$_SESSION['myfaculty_id'];

	$departmentID=$_SESSION['mydepartment_id'];

	$where="";

	switch($groupID)
	{
		case 13:// PG Dean
		break;
		case 9:// Dean UG
		case 3://Faculty examination officer
		if($did)
		{
			$where="AND p.stddepartment_id='$did'";
		}
		$where.="AND p.stdfaculty_id='$facultyID'";
		break;
		case 8://HOD
		case 21://Departmental examination officer
		$where=" AND p.stdfaculty_id='$facultyID'";
		$where.=" AND p.stddepartment_id='$did'";
		break;

		default://Others
		$where="";

		if($did)
		{
			$where="AND p.stddepartment_id='$did'";
		}
		if($fid)
		{
			$where.="AND p.stdfaculty_id='$fid'";
		}
	}

	$sql="SELECT DISTINCT std_mark, std_grade
			FROM students_results 
			WHERE exam_status=1
			AND std_id='$std_id'
			AND std_mark_custom2='$sid'
			AND std_mark_custom1='$semester'
			AND level_id='$lid'
			AND stdcourse_id='$cid'
			 ";

	$res=mysql_query($sql,$connect) or die(mysql_error());
	if(mysql_num_rows($res)>0)
	{
		while($d=mysql_fetch_assoc($res))
		{
			$record=new stdClass();
			$record->std_mark=$d['std_mark'];
			$record->std_grade=$d['std_grade'];
			
			$result[]=$record; 
		}
	}//var_dump($result);exit;
	return $result;
}

function get_hod_examination_officer($dept_id,$fac_id,$eo_group)
{ 
    global $connect,$_SESSION;
	
	$groupID=$_SESSION['groupID'];

	$facultyID=$_SESSION['myfaculty_id'];

	$departmentID=$_SESSION['mydepartment_id'];

	$where="";

	
		if($dept_id && $eo_group!='9')
		{
			$where.="AND department_id='$dept_id'";
		}
	
		if($fac_id)
		{
			$where.="AND faculty_id='$fac_id'";
		}
	
	$sql="SELECT CONCAT(eo_title,' ',eo_surname,' ',eo_firstname,' ',eo_othernames)
		     AS name 
			FROM exam_officers 
			WHERE eo_group='$eo_group'
			$where";

	$res=mysql_query($sql) or die(mysql_error());
	if(mysql_num_rows($res)>0)
	{
		$d=mysql_fetch_assoc($res);
		
			$result=$d['name'];
			
	}//var_dump($result);exit;
	return $result;
}

function get_student_tcue(array $params)
{ //var_dump($params);exit;

    global $connect,$_SESSION;
	$id=(isset($params['student_id']))?$params['student_id']:0;
	$student_level=(isset($params['current_level']))?$params['current_level']:0;
 	$semester="Second Semester";
	
	$sql="SELECT tcue
			FROM students_cgpa
			WHERE std_id='$id'
			AND student_level='$student_level'
			AND student_semester='$semester'";
			
	$res=mysql_query($sql,$connect) or die(mysql_error());
	if(mysql_num_rows($res)>0)
	{
		$d=mysql_fetch_assoc($res);
		
			$result=$d['tcue'];
			
	}
	return $result;
}

?>
