<?php
/**
 * This file handles xml generation 
 * @author  Christian Amaonwu <amakris24@gmail.com>
 */
function createDataXml($arr=array())
{
	$xmlHeader="<departments>";
	$xmlHeader.="<department deptId='0' deptName='--Select One--'/>";
	//template
	$template="<department deptId='%s' deptName='%s'/>";
	if(count($arr))
	{
		foreach($arr as $item)
		{
			$xmlHeader.=sprintf($template,$item->departmentId,$item->departmentName);
		}
		
		
	}
	$xmlHeader.="</departments>";
	return $xmlHeader;
}
function createFacultyXml($arr=array())
{
	$xmlHeader="<facultys>";
	$xmlHeader.="<faculty facultyId='0' facultyName='--Select One--'/>";
	//template
	$template="<faculty facultyId='%s' facultyName='%s'/>";
	if(count($arr))
	{
		foreach($arr as $item)
		{
			$xmlHeader.=sprintf($template,$item->facultyId,$item->facultyName);
		}
		
		
	}
	$xmlHeader.="</facultys>";
	return $xmlHeader;
}
function createLgaXml($arr=array())
{
	$xmlHeader="<lgas>";
	$xmlHeader.="<lga lgaId='0' lgaName='--Select One--'/>";
	//template
	$template="<lga lgaId='%s' lgaName='%s'/>";
	if(count($arr))
	{
		foreach($arr as $item)
		{
			$xmlHeader.=sprintf($template,htmlspecialchars($item->lgaId),htmlspecialchars($item->lgaName,ENT_QUOTES));
		}
		
	}else 
	{
		$xmlHeader.="<lga lgaId='0' lgaName='No LGA for this state'/>";
	}
	$xmlHeader.="</lgas>";
	return $xmlHeader;
}
function createCourseXML($arr=array())
{
	$xmlHeader="<courses>";
	$xmlHeader.="<course courseId='0' courseCode='--Select One--'/>";
	//template
	$template="<course courseId='%s' courseCode='%s'/>";
	if(count($arr))
	{
		foreach($arr as $item)
		{
			$xmlHeader.=sprintf($template,htmlspecialchars($item->courseId),htmlspecialchars($item->courseCode));
		}
		
		
	}else 
	{
		$xmlHeader.="<course courseId='0' courseCode='courses not found for this department'/>";
	}
	$xmlHeader.="</courses>";
	return $xmlHeader;
}
function createStudyXml($arr=array())
{
	$xmlHeader="<studys>";
	$xmlHeader.="<study studyId='0' studyName='--Select One--'/>";
	//template
	$template="<study studyId='%s' studyName='%s'/>";
	if(count($arr))
	{
		foreach($arr as $item)
		{
			$xmlHeader.=sprintf($template,$item->studyId,htmlspecialchars($item->studyName));
		}
		
	}else 
	{
		$xmlHeader.="<study studyId='0' studyName='No course study fields for this department'/>";
	}
	$xmlHeader.="</studys>";
	return $xmlHeader;

}
function createMatricnoXml($arr=array())
{
	$xmlHeader="<matrics>";
	$xmlHeader.="<matric matricId='0' matricName='--Select One--'/>";
	//template
	$template="<matric matricId='%s' matricName='%s'/>";
	if(count($arr))
	{
		foreach($arr as $item)
		{
			$xmlHeader.=sprintf($template,$item->matricId,htmlspecialchars($item->matricName));
		}
		
	}else 
	{
		$xmlHeader.="<matric matricId='0' matricName='No students in this fields of study'/>";
	}
	$xmlHeader.="</matrics>";
	return $xmlHeader;

}
function createDegreeXML($obj)
{
	$xmlHeader="<degrees>";
	$xmlHeader.="<degree degreeId='0' degreeName='--Select One--'/>";
	//template
	$template="<degree degreeId='%s' degreeName='%s'/>";
	if(count($obj))
	{
		foreach($obj as $item)
		{
			$xmlHeader.=sprintf($template,$item->degreeId,htmlspecialchars($item->degreeName));
		}
		
	}else 
	{
		$xmlHeader.="<degree degreeId='0' degreeName='No degrees found for this programme'/>";
	}
	$xmlHeader.="</degrees>";
	return $xmlHeader;
}
function buildXMLData($obj)
{
	$xmlHeader="<hostels>";
	$xmlHeader.="<hostel   hostelId='0' hostelName='--Select One--' />" ;
	  $template="<hostel   hostelId='%s' hostelName='%s' />";
	  
	  if(count($obj))
	  {
	  	 foreach($obj as $item)
	  	 {
	  	 	$xmlHeader.=sprintf($template,htmlspecialchars($item->hostelId),htmlspecialchars($item->hostelName));
	  	 }
	  }else 
	  {
	  	$xmlHeader.="<hostel   hostelId='0' hostelName='No hostel records found' />";
	  }
	  
	  $xmlHeader.="</hostels>";
	  
	  return $xmlHeader;
}
function buildXMLDataRoom($obj)
{
	$xmlHeader="<rooms>";
	$xmlHeader.="<room   roomId='0' roomNo='--Select One--' />" ;
	  $template="<room   roomId='%s' roomNo='%s' />";
	  
	  if(count($obj))
	  {
	  	 foreach($obj as $item)
	  	 {
	  	 	$xmlHeader.=sprintf($template,$item->roomId,htmlspecialchars($item->roomNo));
	  	 }
	  }else 
	  {
	  	$xmlHeader.="<room   roomId='0' roomNo='No rooms found for this block' />";
	  }
	  
	  $xmlHeader.="</rooms>";
	  
	  return $xmlHeader;

}
function buildXMLDataBlock($obj)
{
	$xmlHeader="<blocks>";
	$xmlHeader.="<block   blockId='0' blockName='--Select One--' />" ;
	  $template="<block   blockId='%s' blockName='%s' />";
	  
	  if(count($obj))
	  {
	  	 foreach($obj as $item)
	  	 {
	  	 	$xmlHeader.=sprintf($template,htmlspecialchars($item->blockId),htmlspecialchars($item->blockName));
	  	 }
	  }else 
	  {
	  	$xmlHeader.="<block   blockId='0' blockName='No block records found' />";
	  }
	  
	  $xmlHeader.="</blocks>";
	  
	  return $xmlHeader;
}

?>